function leg_out = add_legend_fcn(my_str,h_ind,leg_pos)

if nargin==0;
   my_str = '';
end;

if nargin<2;
   h_ind = [];
end;

if nargin<3;
   leg_pos = 1;
end;

this_axes = gca;

h = gcf;
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');
this_surf = findobj(this_axes,'Type','surface')';

this_line = findobj(this_axes,'Type','line')';
fixhandles = [];
if isempty(this_line)==0;
   for j=1:size(this_line,2);
      checkvec = get(this_line(1,j),'YData');
      checkvec2 = sum(get(this_line(1,j),'XData'));
      checkstyle = get(this_line(1,j),'LineStyle');
      checktag = get(this_line(1,j),'Tag');
      if size(checktag,2)>8;
         checktag = checktag(1,1:8);
      end;
      if (isalmostequal(checkvec,get(this_line(1,j),'XData'))==1)|(((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(this_line(1,j),'UserData'))==0))|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'3dlines-')==1)|(strcmp(checktag,'2dlines-')==1)|(strcmp(checktag,'light')==1));
         fixhandles = [fixhandles 0];
      else;
         fixhandles = [fixhandles 1];
      end;
   end;
   this_line = this_line(fixhandles==1);
end;

if isempty(this_surf)==1;
   this_patch = findobj(this_axes,'Type','patch')';
   if isempty(this_patch)==0;
      fixhandles = [];
      for j=1:size(this_patch,2);
         checktag = get(this_patch(1,j),'Tag');
         if size(checktag,2)>9;
            checktag = checktag(1,1:9);
         end;
         if (strcmp(checktag,'varpatch-')==1)|(strcmp(checktag,'rectpatch')==1);
            fixhandles = [fixhandles 0];
         else;
            fixhandles = [fixhandles 1];
         end;
      end;
      this_patch = this_patch(fixhandles==1);
   end;
else;
   this_patch = [];
end;

%
% Create a legend based on available data unless there is no data
%

data_objects = sort([this_line this_patch this_surf]);

if isempty(data_objects)==1;
   if nargout==1;
      leg_out = 0;
   end;
   return;
elseif (isempty([this_line this_patch])==1)&(size(this_surf,2)==1);
   if ischar(get(this_surf,'UserData'))==0;
      if nargout==1;
         leg_out = 0;
      end;
      return;
   end;
end;

if isempty(h_ind)==0;
   if size(h_ind,2)<size(data_objects,2);
      for i=size(h_ind,2)+1:size(data_objects,2);
         h_ind = [h_ind i];
      end;
   elseif size(h_ind,2)>size(data_objects,2);
      h_ind = h_ind(1,1:size(data_objects,2));
   end;
   h_leg_objects = zeros(size(h_ind));
   for i1=1:size(h_ind,2);
      h_leg_objects(1,h_ind(1,i1)) = data_objects(1,i1);
   end;
   data_objects = h_leg_objects;
end;

if isempty(my_str)==1;
   for i=1:size(data_objects,2);
      new_str = ['Item ' num2str(i)];
      my_str = strvcat(my_str,new_str);
   end;
else;
   if size(my_str,1)<size(data_objects,2);
      %
      % adding a line or patch
      %
      my_str = strvcat(my_str,['Item ' num2str(size(data_objects,2))]);
      %
      % resort my_str if data_objects do not match the reverse order of gca children
      %
%      my_str = reorder_str_fcn(this_axes,data_objects,my_str);
   end;
end;

new_leg = legend_fcn(data_objects,my_str,leg_pos);

%
% make sure that legends text string behave properly
%

legstringhandles = findobj(new_leg,'Type','text')';

%
% fix font and font color with new text objects
%

for i=1:size(legstringhandles,2);
   set(legstringhandles(1,i),'Color',get(get(this_axes,'XLabel'),'Color'));
   set(legstringhandles(1,i),'FontAngle',get(this_axes,'FontAngle'));
   set(legstringhandles(1,i),'FontName',get(this_axes,'FontName'));
   set(legstringhandles(1,i),'FontSize',get(this_axes,'FontSize'));
   set(legstringhandles(1,i),'FontWeight',get(this_axes,'FontWeight'));
   set(legstringhandles(1,i),'FontUnits',get(this_axes,'FontUnits'));
end;

%
% Add lines and patches in legend as user data for lines and patches
% in graphs
%

leg_ud = get(new_leg,'UserData');
num = 1;
for i=1:size(leg_ud.LabelHandles,1);
   if strcmp(get(leg_ud.LabelHandles(i,1),'Type'),'text')==0;
      if num<=size(leg_ud.handles,2);
         if strcmp(get(leg_ud.handles(num),'Type'),'surface')==0;
            set(leg_ud.handles(num),'UserData',leg_ud.LabelHandles(i));
         end;
         num = num+1;
      else;
         break;
      end;
   end;
end;

%
% Add a context menu to the legend
%

old_units = get(this_axes,'Units');
set(this_axes,'Units','normalized');
set(new_leg,'Units','pixels');
legpos = get(new_leg,'Position');
set(new_leg,'Units','normalized');
leg_ud = get(new_leg,'UserData');
leg_ud.AxesPosition = get(this_axes,'Position');
leg_ud.PlotPosition = get(this_axes,'Position');
leg_ud.LegendPosition = get(new_leg,'Position');
legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
uimenu('Parent',legcontext,'Label','Reorder Legend','Separator','on','Callback','reorder_legend_fcn');
uimenu('Parent',legcontext,'Label','Hide Legend','Separator','on','Callback','toolbar_legend_fcn');
uimenu('Parent',legcontext,'Label','Lock Legend','Separator','on','Callback','legend_lock_fcn');
leg_ud.UIContextMenu = legcontext;
set(new_leg,'UIContextMenu',legcontext,'UserData',leg_ud);
set(get(new_leg,'Children'),'UIContextMenu',legcontext);
set(this_axes,'Units',old_units);

%
% set legend handle as user data for axes object
%

set(this_axes,'UserData',new_leg);

%
% delete old context menu and create a new one
%

create_axes_contextmenu_fcn(this_axes);

%
% make sure that uimenu allows us to show legend
%

set(toolbar.legend,'Enable','on');
leg_toolbar_label = get(toolbar.legend,'Label');
if strcmp(leg_toolbar_label,'Hide &Legend')==0;
   toolbar_legend_fcn;
end;

%
% reset legend positions data for toolbar.edit UserData info (legpos new variable)
%

if isempty(get(toolbar.edit,'UserData'))==1;
   set(toolbar.edit,'UserData',legpos);
else;
   all_leg_handles = [];
   for i=1:size(myaxes,2);
      new_leg_handle = get(myaxes(1,i),'UserData');
      if isempty(new_leg_handle)==0;
         if ishandle(new_leg_handle)==1;
            all_leg_handles = [all_leg_handles new_leg_handle];
         end;
      end;
   end;
   thislegpos = [];
   for i=1:size(all_leg_handles,2);
      old_units = get(all_leg_handles(1,i),'Units');
      set(all_leg_handles(1,i),'Units','pixels');
      newlegpos = get(all_leg_handles(1,i),'Position');
      thislegpos = [thislegpos;newlegpos];
      set(all_leg_handles(1,i),'Units',old_units);
      set(toolbar.edit,'UserData',thislegpos);
   end;
end;

if nargout==1;
   leg_out = new_leg;
end;

%
% end of add_legend_fcn.m
%
