function addrectangle_fcn

h = get(0,'CurrentFigure');

%
% make sure we have a single left click from the mouse
% i.e. SelectionType=normal
%

st = get(h,'SelectionType');
if strcmp(st,'normal')==0;
   return;
end;

toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% make sure where dealing with a proper axes
%

valid_axes = 0;
for i=1:size(myaxes,2);
   if gca==myaxes(1,i);
      valid_axes = 1;
      break;
   end;
end;

if valid_axes==0;
   return;
end;

%
% now we can create a new line object
%

cp = get(h,'CurrentPoint');


old_axes_units = get(gca,'Units');
set(gca,'Units','pixels');
axes_pos = get(gca,'Position');
set(gca,'Units',old_axes_units);

%
% make sure current point is accurate relative to the axes scale
%

axes_cp = get(gca,'CurrentPoint');
axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;

x_lim = get(gca,'XLim');
y_lim = get(gca,'YLim');

this_line = line('XData',axes_cp(1,1), ...
   'YData',axes_cp(1,2), ....
   'LineStyle','-', ...
   'Color',[0 0 0], ...
   'Marker','none', ...
   'LineWidth',1, ...
   'Selection','on', ...
   'Tag',['nolegend-' num2str(axes_cp(1),'%0.0f') '-' num2str(axes_cp(2),'%0.0f') '-' num2str(axes_cp(3),'%0.0f')]);

set(toolbar.rectangle,'UserData',this_line);

%
% Add new windowbuttonup, windowbuttondown, and windowbuttonmothion functions
%

set(gca,'XLim',x_lim,'YLim',y_lim);
set(h,'WindowButtonMotionFcn','update_rectangle_fcn');
set(h,'WindowButtonDownFcn','save_rectangle_fcn');
set(h,'WindowButtonUpFcn','save_rectangle_fcn');
set(h,'DoubleBuffer','on');

%
% end of addrectangle_fcn.m
%
