function addtext_fcn

h = get(0,'CurrentFigure');

%
% make sure we have a single left click from the mouse
% i.e. SelectionType=normal
%

st = get(h,'SelectionType');
if strcmp(st,'normal')==0;
   return;
end;

toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% make sure where dealing with a proper axes
%

valid_axes = 0;
for i=1:size(myaxes,2);
   if gca==myaxes(1,i);
      valid_axes = 1;
      break;
   end;
end;

if valid_axes==0;
   return;
end;

curr_ini = find_inisettings;

%
% now we can create a new text object
%

cp = get(h,'CurrentPoint');
%pos = get(toolbar.addtext,'Position');

%
% make sure current point is not to high
%

%if cp(2)>=pos(2)-6;
%   return;
%end;

%
% use current point from the current axes objects
%

ax_cp = get(gca,'CurrentPoint');
if ax_cp(1,3)+ax_cp(2,3)==0;
   ax_cp = [ax_cp(1,1:2) 0];
else;
   ax_cp = ax_cp(1,:);
end;

this_text = text('Units','data', ...
   'Position',ax_cp, ...
   'String',' ', ...
   'Editing','on', ...
   'HorizontalAlignment','center', ...
   'VerticalAlignment','middle', ...
   'Color',curr_ini.axes_color, ...
   'FontName',curr_ini.axes_fontname, ...
   'FontSize',curr_ini.axes_fontsize, ...
   'FontWeight',curr_ini.axes_fontweight, ...
   'FontUnits',curr_ini.axes_fontunits, ...
   'FontAngle',curr_ini.axes_fontangle, ...
   'Tag',['Text' num2str(ax_cp(1),'%1.0f') '-' num2str(ax_cp(2),'%1.0f') '-' num2str(ax_cp(3),'%1.0f')]);

%
% Define a UIContextMenu and a ButtonDownFcn callback
%

text_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',text_context_menu,'Label','Edit','Callback','set(gco,''Editing'',''on'')');
uimenu('Parent',text_context_menu,'Label','Cut','Callback','delete(gco); empty_axes');
uimenu('Parent',text_context_menu,'Separator','on','Label','Font','Callback','change_text_font');
uimenu('Parent',text_context_menu,'Label','Font Color','Callback','change_text_color');
set(this_text,'UIContextMenu',text_context_menu,'ButtonDownFcn','check_text_fcn');

set(this_text,'Units','data');

%
% change the window button down function to make sure that a new text
% object is not immediately created when clicking on the figure
%

set(h,'WindowButtonDownFcn','savetext_fcn');

%
% end of addtext_fcn.m
%
