function copy_surface_fcn

curr_surface = gco;
surface_prop.xdata = get(curr_surface,'XData');
surface_prop.ydata = get(curr_surface,'YData');
surface_prop.zdata = get(curr_surface,'ZData');
surface_prop.linestyle = get(curr_surface,'LineStyle');
surface_prop.linewidth = get(curr_surface,'LineWidth');
surface_prop.tag = get(curr_surface,'Tag');
surface_prop.edgecolor = get(curr_surface,'EdgeColor');
surface_prop.facecolor = get(curr_surface,'FaceColor');
surface_prop.cdata = get(curr_surface,'CData');
surface_prop.cdatamapping = get(curr_surface,'CDataMapping');
surface_prop.ambientstrength = get(curr_surface,'AmbientStrength');
surface_prop.backfacelighting = get(curr_surface,'BackFaceLighting');
surface_prop.diffusestrength = get(curr_surface,'DiffuseStrength');
surface_prop.edgelighting = get(curr_surface,'EdgeLighting');
surface_prop.facelighting = get(curr_surface,'FaceLighting');
surface_prop.specularcolorreflectance = get(curr_surface,'SpecularColorReflectance');
surface_prop.specularexponent = get(curr_surface,'SpecularExponent');
surface_prop.specularstrength = get(curr_surface,'SpecularStrength');
surface_prop.marker = get(curr_surface,'Marker');
surface_prop.markersize = get(curr_surface,'MarkerSize');
surface_prop.markeredgecolor = get(curr_surface,'MarkerEdgeColor');
surface_prop.markerfacecolor = get(curr_surface,'MarkerFaceColor');
surface_prop.self = curr_surface;
surface_prop.userdata = get(curr_surface,'UserData');
surface_prop.axesview = get(gca,'View');
surface_prop.colormap = get(gcf,'Colormap');

%
% copy the light object as well
%

this_light = findobj(gca,'Type','light')';
surface_prop.light.color = get(this_light,'Color');
surface_prop.light.position = get(this_light,'Position');
surface_prop.light.style = get(this_light,'Style');
surface_prop.light.userdata = get(this_light,'UserData');

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');

update_figs = 0;
if isfield(copy,'surface_properties')==0;
   update_figs = 1;
end;
copy.surface_properties = surface_prop;
set(model.run,'UserData',copy);

%
% update all open figure such that pasting of lines are enabled
%

if update_figs==1;
   my_figs = sort(findobj(0,'Type','figure')');
   for i=1:size(my_figs,2);
      this_toolbar = get(my_figs(1,i),'UserData');
      if isempty(this_toolbar)==0;
         %
         % make sure we're not dealing with a program figure
         %
         if isfield(this_toolbar,'renderer')==1;
            myaxes = get(this_toolbar.print,'UserData');
            for j=1:size(myaxes,2);
               surface_menu = findobj(get(myaxes(1,j),'UIContextMenu'),'Label','Surface')';
               if isempty(surface_menu)==0;
                  set(surface_menu,'Enable','on');
               end;
            end;
         end;
      end;
   end;
end;

%
% end of copy_surface_fcn.m
%
