function delete_axes_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');
old_axes = gca;

%
% remove axes info in toolbar.print
%

newaxes = [];
for i=1:size(myaxes,2);
   if isequal(myaxes(1,i),old_axes)==0;
      newaxes = [newaxes myaxes(1,i)];
   end;
end;

set(toolbar.print,'UserData',newaxes);
delete(old_axes);

%
% delete any colorbar linked to this axes
%

this_colorbar = findobj(h,'Type','axes','Tag','colorbar')';
if isempty(this_colorbar)==0;
   for j=1:size(this_colorbar,2);
      if old_axes==get(this_colorbar(1,j),'UserData');
         kids = get(this_colorbar(1,j),'Children')';
         delete(kids);
         delete(this_colorbar(1,j));
         break;
      end;
   end;
end;

if size(newaxes,2)==1;
   create_axes_contextmenu_fcn(newaxes);
end;

%
% fix all legend positions
%

if isempty(get(toolbar.edit,'UserData'))==0;
   all_leg_handles = [];
   for i=1:size(newaxes,2);
      new_leg_handle = get(newaxes(1,i),'UserData');
      if isempty(new_leg_handle)==0;
         if ishandle(new_leg_handle)==1;
            all_leg_handles = [all_leg_handles new_leg_handle];
         end;
      end;
   end;
   thislegpos = [];
   for i=1:size(all_leg_handles,2);
      old_units = get(all_leg_handles(1,i),'Units');
      set(all_leg_handles(1,i),'Units','pixels');
      newlegpos = get(all_leg_handles(1,i),'Position');
      thislegpos = [thislegpos;newlegpos];
      set(all_leg_handles(1,i),'Units',old_units);
      set(toolbar.edit,'UserData',thislegpos);
   end;
end;

%
% end of delete_axes_fcn.m
%
