function delete_surface_fcn

curr_obj = gco;

if ischar(get(gco,'UserData'))==1;
   this_light = findobj(gca,'Type','light')';
   if gco==get(this_light,'UserData');
      del_light = 1;
      all_surf = sort(findobj(gca,'Type','surface')');
      if isempty(all_surf)==0;
         for i=1:size(all_surf,2);
            if gco~=all_surf(1,i);
               if ischar(get(all_surf(1,i),'UserData'))==1;
                  del_light = 0;
                  set(this_light,'UserData',all_surf(1,i));
                  break;
               end;
            end;
         end;
         %
         % search for planes with the same context menu as the surface to delete
         %
         for i=1:size(all_surf,2);
            if gco~=all_surf(1,i);
               if get(gco,'UIContextMenu')==get(all_surf(1,i),'UIContextMenu');
                  surface_context = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
                  uimenu('Parent',surface_context,'label','Cut','Callback','delete_surface_fcn');
                  set(all_surf(1,i),'UIContextMenu',surface_context);
                  break;
               end;
            end;
         end;
      end;
      if del_light==1;
         delete(this_light);
         %
         % we also need to delete the line object created earlier
         %
         light_line = findobj(gca,'Type','line','UserData','light')';
         delete(light_line);
      end;
   end;
   delete(gco);
else;
   delete(gco);
end;

all_surf = sort(findobj(gca,'Type','surface')');
if isempty(all_surf)==1;
   set(gca,'View',[0 90],'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1]);
   if isempty(get(gca,'UserData'))==0;
      if ishandle(get(gca,'UserData'))==1;
         all_lines = findobj(gca,'Type','line')';
         all_patches = findobj(gca,'Type','patch')';
         if isempty([all_lines all_patches])==1;
            delete_legend_fcn;
         end;
      end;
   end;
else;
   if isempty(get(gca,'UserData'))==0;
      if ishandle(get(gca,'UserData'))==1;
         %
         % retrieve strings from old legend
         %
         old_leg = get(gca,'UserData');
         leg_ud = get(old_leg,'UserData');
         old_strings = leg_ud.lstrings;
         curr_objects = leg_ud.handles;
         %
         % best guess is last text string
         %
         del_line_num = size(old_strings,2);
         for i=1:size(curr_objects,2);
            if curr_obj==curr_objects(1,i);
               del_line_num = i;
               break;
            end;
         end;
         my_strings = '';
         for i=1:size(old_strings,2);
            if (i<del_line_num)|(i>del_line_num);
               my_strings = strvcat(my_strings,old_strings{i});
            end;
         end;
         %
         % now we fix the legend
         %
         delete_legend_fcn;
         add_legend_fcn(my_strings);
      end;
   end;
end;

%
% need to fix axes context menu
%
create_axes_contextmenu_fcn(gca);

%
% fix toolbar if we have an empty plot
%

toolbar = get(gcf,'UserData');
myaxes = get(toolbar.print,'UserData');
surfhandles = [];
for i=1:size(myaxes,2);
   surfhandles = [surfhandles findobj(myaxes(1,i),'Type','surface')'];
end;

if isempty(surfhandles)==1;
   if isfield(toolbar,'rotate3d')==1;
      fix_toolbar_fcn;
   end;
   set(gcf,'Colormap',jet);
else;
   check_surf_type = [];
   for i=1:size(surfhandles,2);
      if ischar(get(surfhandles(1,i),'UserData'))==1;
         check_surf_type = [check_surf_type 1];
      else;
         check_surf_type = [check_surf_type 0];
      end;
   end;
   if sum(check_surf_type)==0;
      %
      % delete all planes that are not visible
      %
      for i=1:size(surfhandles,2);
         if strcmp(get(surfhandles(1,i),'Visible'),'off')==1;
            delete(surfhandles(1,i));
         end;
      end;
      %
      % delete colorbars
      %
      this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
      if isempty(this_colorbar)==0;
         for j=1:size(this_colorbar,2);
            if gca==get(this_colorbar(1,j),'UserData');
               delete_colorbar_fcn(this_colorbar(1,j));
               break;
            end;
         end;
      end;
      %
      % update axes and legends if needed
      %
      for i=1:size(myaxes,2);
         this_surfhandle = findobj(myaxes(1,i),'Type','surface')';
         if isempty(this_surfhandle)==1;
            set(myaxes(1,i),'View',[0 90],'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1]);
            if isempty(get(myaxes(1,i),'UserData'))==0;
               if ishandle(get(myaxes(1,i),'UserData'))==1;
                  all_lines = findobj(myaxes(1,i),'Type','line')';
                  all_patches = findobj(myaxes(1,i),'Type','patch')';
                  if isempty([all_lines all_patches])==1;
                     delete_legend_fcn;
                  end;
               end;
            end;
         end;
         %
         % fix axes context menu
         %
         create_axes_contextmenu_fcn(myaxes(1,i));
      end;
      %
      % update toolbar if needed
      %
      if isfield(toolbar,'rotate3d')==1;
         fix_toolbar_fcn;
      end;
      set(gcf,'Colormap',jet);
   elseif sum(check_surf_type)==size(check_surf_type,2);
      if isfield(toolbar,'showhidesurface')==1;
         delete(toolbar.showhidesurface);
         toolbar = rmfield(toolbar,'showhidesurface');
         set(gcf,'UserData',toolbar);
      end;
   else;
      this_surf_type = [];
      this_surfhandle = findobj(gca,'Type','surface')';
      if isempty(this_surfhandle)==0;
         for i1=1:size(this_surfhandle,2);
            if ischar(get(this_surfhandle(1,i1),'UserData'))==1;
               this_surf_type = [this_surf_type 1];
            else;
               this_surf_type = [this_surf_type 0];
            end;
         end;
         this_surfhandle = this_surfhandle(this_surf_type==1);
      end;
      if isempty(this_surfhandle)==1;
         %
         % delete colorbar
         %
         this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
         if isempty(this_colorbar)==0;
            for j=1:size(this_colorbar,2);
               if gca==get(this_colorbar(1,j),'UserData');


                  old_cunits = get(this_colorbar(1,j),'Units');
                  set(this_colorbar(1,j),'Units','pixels');
                  colorbar_pos = get(this_colorbar(1,j),'Position');
                  set(this_colorbar(1,j),'Units',old_cunits);
                  %
                  old_aunits = get(gca,'Units');
                  set(gca,'Units','pixels');
                  curr_axes_pos = get(gca,'Position');
                  %
                  kids = get(this_colorbar(1,j),'Children')';
                  set(this_colorbar(1,j),'Visible','off');
                  set(kids,'Visible','off');
                  new_axes_pos = [curr_axes_pos(1:2) colorbar_pos(1)+colorbar_pos(3)-curr_axes_pos(1) curr_axes_pos(4)];
                  set(gca,'Position',new_axes_pos);
                  break;
               end;
            end;
         end;
      end;
   end;
end;

%
% end of delete_surface_fcn.m
%
