function fix_toolbar_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% fix toolbar from 2D to 3D and vice versa by deleting old toolbar
% while keeping all user data and setting up a new
%
toolbar_fields = fieldnames(toolbar);
%
% delete old toolbar, but store user data from toolbar fields into old_toolbar structure.
% these values are then reset into user data of new toolbar
%
old_toolbar = [];
for i=1:size(toolbar_fields,1);
   if ishandle(getfield(toolbar,toolbar_fields{i}))==1;
      if isempty(get(getfield(toolbar,toolbar_fields{i}),'UserData'))==0;
         old_toolbar = setfield(old_toolbar,toolbar_fields{i},get(getfield(toolbar,toolbar_fields{i}),'UserData'));
      end;
      delete(getfield(toolbar,toolbar_fields{i}));
   end;
end;
%
% delete uimenus
%
my_tools = findobj(gcf,'Tag','ToolsMenu')';
my_files = findobj(gcf,'Tag','FileMenu')';
my_edits = findobj(gcf,'Tag','EditMenu')';
my_helps = findobj(gcf,'Tag','HelpMenu')';
if isempty(my_files)==0;
   for i=1:size(my_files,2);
      delete(my_files(1,i));
   end;
end;
if isempty(my_tools)==0;
   for i=1:size(my_tools,2);
      delete(my_tools(1,i));
   end;
end;
if isempty(my_edits)==0;
   for i=1:size(my_edits,2);
      delete(my_edits(1,i));
   end;
end;
if isempty(my_helps)==0;
   for i=1:size(my_helps,2);
      delete(my_helps(1,i));
   end;
end;
%
% check for the existence of a colorbar
%
this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
if isempty(this_colorbar)==0;
   if strcmp(get(this_colorbar,'Visible'),'on')==1;
      old_axes_handle = get(this_colorbar,'UserData');
      set(this_colorbar,'UserData',[]);
   end;
end;

if isempty(this_colorbar)==0;
   if strcmp(get(this_colorbar,'Visible'),'on')==1;
      set(this_colorbar,'UserData',old_axes_handle);
   end;
end;
%
% set up new toolbar
%
toolbar_fcn(myaxes);
toolbar = get(gcf,'UserData');
for i=1:size(toolbar_fields,1);
   if isfield(old_toolbar,toolbar_fields{i})==1;
      if (isempty(getfield(old_toolbar,toolbar_fields{i}))==0)&(strcmp(toolbar_fields{i},'saveas')==0)&(isfield(toolbar,toolbar_fields{i})==1)&(strcmp(toolbar_fields{i},'alignment')==0)&(strcmp(toolbar_fields{i},'about')==0);
         set(getfield(toolbar,toolbar_fields{i}),'UserData',getfield(old_toolbar,toolbar_fields{i}))
      end;
   end;
end;

%
% end of fix_toolbar_fcn.m
%
