%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          Computes value of the log likelihood function for     %
%          a normal distribution                                 %
%                                                                %
%          Function: loglikefcn                                  %
%                                                                %
%          Input:                                                %
%                       Omega: nxn covariance matrix             %
%                       epsilon: nxT matrix with residuals       %
%                                                                %
%          Output:                                               %
%          	            lnl: value of log likelihood function    %
%                                                                %
%          This version:        April 13, 2005                   %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2005          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function lnl = loglikefcn(Omega,epsilon)

[n T] = size(epsilon);

lnl = -(T/2)*(n*log(2*pi)+log(det(Omega)))-((1/2)*sum(diag(inverse(Omega)*epsilon*epsilon')));

%
% end of loglikefcn.m
%
