function [tests,pvals,dfs] = longrun_dummies(epsilon_orig,Z0,Z1,Z2,deter,r,p,pe,q1,q0,df,num_const,num_dummies,restrict,modelsdir,modelfile,dcoint,reestbeta,sscorrect,showwaitbar)

[n T] = size(epsilon_orig);
lnL_orig = loglike(epsilon_orig);
t = T-df;
%
dummy_names = vecstr(deter);
dummy_names = dummy_names(1+num_const:num_dummies+num_const,:);

if num_dummies>1;
   tests = zeros(num_dummies+1,1);
   pvals = zeros(num_dummies+1,1);
   dfs = zeros(num_dummies+1,1+sscorrect);
else;
   tests = zeros(1,1);
   pvals = zeros(1,1);
   dfs = zeros(1,1+sscorrect);
end;

Z2_const = [];
Z2_base = [];
if num_const>0;
   Z2_const = Z2(1:num_const,:);
end;
if size(Z2,1)>num_const+num_dummies;
   Z2_base = [Z2(num_const+num_dummies+1:size(Z2,1),:)];
end;
dummy_series = (1:1:num_dummies)';
Z2_dummy_vars = Z2(num_const+1:num_dummies+num_const,:);
%
% create restrictions files for beta in case beta is restricted
%
if restrict(1,2)==1;
   file_norm = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
   if fileexist(file_norm)==1;
      norm_vec = loaddata(file_norm);
   else;
      norm_vec = (1:1:r)';
   end;
   file_norm_new = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+1),'-',modelfile,'.norm');
   if fileexist(file_norm_new)==1;
      file_norm_cp = [file_norm_new '.bak'];
      rename_file_fcn(file_norm_new,file_norm_cp);
   end;
   %
   % save the normalisations
   %
   fid = fopen(file_norm_new,'wt');
   fprintf(fid,'%0.0f\n',norm_vec');
   fclose(fid);
   for i=1:r;
      file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
      if fileexist(file)==1;
         h = loaddata(file);
         h = [h zeros(size(h,1),1);zeros(1,size(h,2)) 1];
         file_new = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+1),'-',modelfile,'.rest');
         if fileexist(file_new)==1;
            %
            % create a backup copy of the original
            %
            file_cp = [file_new '.bak'];
            rename_file_fcn(file_new,file_cp);
         end;
         fid = fopen(file_new,'wt');
         prt_str = '';
         for j=1:size(h,2);
            prt_str = [prt_str ' %2.4f'];
         end;
         fprintf(fid,[prt_str '\n'],h');
         fclose(fid);
      else;
         restrict(1,2)==0;
      end;
   end;
   %
   % for the joint test
   %
   if num_dummies>1;
      file_norm = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
      if fileexist(file_norm)==1;
         norm_vec = loaddata(file_norm);
      else;
         norm_vec = (1:1:r)';
      end;
      file_norm_new = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+num_dummies),'-',modelfile,'.norm');
      if fileexist(file_norm_new)==1;
         file_norm_cp = [file_norm_new '.bak'];
         rename_file_fcn(file_norm_new,file_norm_cp);
      end;
      %
      % save the normalisations
      %
      fid = fopen(file_norm_new,'wt');
      fprintf(fid,'%0.0f\n',norm_vec');
      fclose(fid);
      for i=1:r;
         file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
         if fileexist(file)==1;
            h = loaddata(file);
            h = [h zeros(size(h,1),num_dummies);zeros(num_dummies,size(h,2)) eye(num_dummies)];
            file_new = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+num_dummies),'-',modelfile,'.rest');
            if fileexist(file_new)==1;
               %
               % create a backup copy of the original
               %
               file_cp = [file_new '.bak'];
               rename_file_fcn(file_new,file_cp);
            end;
            fid = fopen(file_new,'wt');
            prt_str = '';
            for j=1:size(h,2);
               prt_str = [prt_str ' %2.4f'];
            end;
            fprintf(fid,[prt_str '\n'],h');
            fclose(fid);
         else;
            restrict(1,2)==0;
         end;
      end;
   end;
end;

if showwaitbar==1;
   txt = strvcat(' ','Computing zero long-run tests for dummy variables...',['Current dummy variable: ' strtrim(dummy_names(1,:))],'Please wait!');
   mywait = waitdlg(txt,'information');
   waitf = get(mywait,'UserData');
end;

for i=1:num_dummies;
   if (showwaitbar==1)&(i>1);
      txt = strvcat(' ','Computing zero long-run tests for dummy variables...',['Current dummy variable: ' strtrim(dummy_names(i,:))],'Please wait!');
      set(waitf.text,'String',txt);
   end;
   %
   if num_dummies>1;
      use_dummies = dummy_series(dummy_series~=i);
      Z2_new = [Z2_const;Z2_dummy_vars(use_dummies,:);Z2_base];
   else;
      Z2_new = [Z2_const;Z2_base];
   end;
   %
   % create new Z1
   %
   Z1_new = [Z1;Z2_dummy_vars(i,:)];
   %
   % estimate model under the null hypothesis
   %
   [S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(Z0,Z1_new,Z2_new,r);
   %
   if restrict(1,2)==1;
      [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,modelsdir,modelfile,0,dcoint);
   end;
   alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
   if isempty(Z2_new)==0;
      Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      Z3 = [Z2_new;beta_n'*Z1_new];
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      Z3 = beta_n'*Z1_new;
   end;
   %
   % estimate under alpha restrictions
   %
   Theta_n = [Psi_n alpha_n];
   if restrict(1,1)==1;
      if i==1;
         %
         % retrieve the restrictions on alpha
         %
         file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
         G = loaddata(file);
         [Rmat,rvec] = rmatrix(G,n,r);
         dfalpha = size(G,1);
         if isempty(Z2_new)==0;
            Rmat = [zeros(dfalpha,size(Z2_new,1)*n) Rmat];
         end;
      end;
      if reestbeta==0;
         [theta_n,Sigma_theta,infomat,newabort] = linrest(Z0,Z3,Theta_n,Rmat,rvec,0);
      else;
         [theta_n,Sigma_theta,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(Z0,Z1_new,Z2_new,Z3,beta_n,Theta_n,Rmat,rvec,dcoint+1,q1,modelsdir,modelfile,0);
      end;
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      end;
   end;
   %
   % estimate under C restrictions
   %
   if (size(restrict,2)==3)&(restrict(1,3)==1);
      if i==1;
         file = strcat(modelsdir,'C-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
         G = loaddata(file);
         [Rmat_C,rvec_C] = rmatrix(G,n,n);
      end;
      %
      [theta_n,Sigma_theta,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(Z0,Z1_new,Z2_new,restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,p,pe,num_const+num_dummies-1,dcoint+1,q0,q1,modelsdir,modelfile,0);
      %
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      end;
   end;
   %
   lnL_new = loglike(epsilon_n);
   LR = 2*(lnL_orig-lnL_new);
   if LR<0;
      LR = 0;
   end;
   if sscorrect==0;
      tests(i,1) = LR;
      pvals(i,1) = 1-chis_cdf(LR,n-r);
      dfs(i,1) = n-r;
   else;
      dfs(i,:) = [n-r t+r-1];
      tests(i,1) = ((t+r-1)/(T*(n-r)))*LR;
      pvals(i,1) = 1-fdis_cdf(tests(i,1),dfs(i,1),dfs(i,2));
   end;
end;

%
% and now for the joint test
%
if num_dummies>1;
   if showwaitbar==1;
      txt = strvcat(' ','Computing zero long-run tests for all dummy variables...',' ','Please wait!');
      set(waitf.text,'String',txt);
   end;
   Z2_new = [Z2_const;Z2_base];
   Z1_new = [Z1;Z2_dummy_vars];
   %
   % estimate model under the null hypothesis
   %
   [S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(Z0,Z1_new,Z2_new,r);
   %
   if restrict(1,2)==1;
      [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,modelsdir,modelfile,0,dcoint);
   end;
   alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
   if isempty(Z2_new)==0;
      Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      Z3 = [Z2_new;beta_n'*Z1_new];
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      Z3 = beta_n'*Z1_new;
   end;
   %
   % estimate under alpha restrictions
   %
   Theta_n = [Psi_n alpha_n];
   if restrict(1,1)==1;
      %
      % retrieve the restrictions on alpha
      %
      file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
      G = loaddata(file);
      [Rmat,rvec] = rmatrix(G,n,r);
      dfalpha = size(G,1);
      if isempty(Z2_new)==0;
         Rmat = [zeros(dfalpha,size(Z2_new,1)*n) Rmat];
      end;
      %
      if reestbeta==0;
         [theta_n,Sigma_theta,infomat,newabort] = linrest(Z0,Z3,Theta_n,Rmat,rvec,0);
      else;
         [theta_n,Sigma_theta,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(Z0,Z1_new,Z2_new,Z3,beta_n,Theta_n,Rmat,rvec,dcoint+num_dummies,q1,modelsdir,modelfile,0);
      end;
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      end;
   end;
   %
   % estimate under C restrictions
   %
   if (size(restrict,2)==3)&(restrict(1,3)==1);
      file = strcat(modelsdir,'C-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
      G = loaddata(file);
      [Rmat_C,rvec_C] = rmatrix(G,n,n);
      %
      [theta_n,Sigma_theta,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(Z0,Z1_new,Z2_new,restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,p,pe,num_const,dcoint+num_dummies,q0,q1,modelsdir,modelfile,0);
      %
      g2 = size(theta_n,2);
      alpha_n = theta_n(:,g2-r+1:g2);
      if g2>r;
         Psi_n = theta_n(:,1:g2-r);
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new)-(Psi_n*Z2_new);
      else;
         Psi_n = [];
         epsilon_n = Z0-(alpha_n*beta_n'*Z1_new);
      end;
   end;
   %
   lnL_new = loglike(epsilon_n);
   LR = 2*(lnL_orig-lnL_new);
   if LR<0;
      LR = 0;
   end;
   if sscorrect==0;
      tests(num_dummies+1,1) = LR;
      pvals(num_dummies+1,1) = 1-chis_cdf(LR,n*num_dummies);
      dfs(num_dummies+1,1) = (n-r)*num_dummies;
   else;
      dfs(num_dummies+1,:) = [(n-r)*num_dummies t+floor((num_dummies*(n-r))/n)-1];
      tests(num_dummies+1,1) = (dfs(num_dummies+1,2)/(T*dfs(num_dummies+1,1)))*LR;
      pvals(num_dummies+1,1) = 1-fdis_cdf(tests(num_dummies+1,1),dfs(num_dummies+1,1),dfs(num_dummies+1,2));
   end;
end;

%
% delete any files we may have created
%

if restrict(1,2)==1;
   file_norm_new = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+1),'-',modelfile,'.norm');
   delete_file_fcn(file_norm_new);
   file_norm_cp = [file_norm_new '.bak'];
   if fileexist(file_norm_cp)==1;
      rename_file_fcn(file_norm_cp,file_norm_new);
   end;
   for i=1:r;
      file_new = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+1),'-',modelfile,'.rest');
      delete_file_fcn(file_new);
      file_cp = [file_new '.bak'];
      if fileexist(file_cp)==1;
         rename_file_fcn(file_cp,file_new);
      end;
   end;
   %
   % for the joint test
   %
   if num_dummies>1;
      file_norm_new = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+num_dummies),'-',modelfile,'.norm');
      delete_file_fcn(file_norm_new);
      file_norm_cp = [file_norm_new '.bak'];
      if fileexist(file_norm_cp)==1;
         rename_file_fcn(file_norm_cp,file_norm_new);
      end;
      for i=1:r;
         file_new = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+num_dummies),'-',modelfile,'.rest');
         delete_file_fcn(file_new);
         file_cp = [file_new '.bak'];
         if fileexist(file_cp)==1;
            rename_file_fcn(file_cp,file_new);
         end;
      end;
   end;
end;

if showwaitbar==1;
   set(waitf.text,'UserData','done');
   delete(mywait);
   drawnow;
end;

%
% end of longrun_dummies.m
%
