%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for creating the matrix Nn, based     %
%          on the commutation matrix, for vec(A)+vec(A')         %
%          simplifications when A is nxn                         %
%                                                                %
%          Function: ncommutation                                %
%                                                                %
%          Input:                                                %
%                        n: integer (dimension)                  %
%                                                                %
%          Output:                                               %
%          		           Nn: n^2xn^2 0-1 matrix                  %
%                                                                %
%          This version:        April 20, 2006                   %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2006          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Nn = ncommutation(n)

Knn = commutation(n,n);

Nn = (1/2)*(eye(n*n)+Knn);