function h = pagesetup_fcn(selector,my_center_value_,my_fill_value_,my_crop_image_)

if nargin>1;
   curr_ini.center_value = my_center_value_;
   curr_ini.fill_value = my_fill_value_;
   curr_ini.crop_image = my_crop_image_;
   oldcurr_ini.crop_image = my_crop_image_;
end;

if (nargin==0)|((ishandle(selector)==1)&(strcmp(get(selector,'Type'),'figure')==1));
   if nargin==0;
      selector = 'init';
   end;
   if isempty(selector)==0;
      figname = get(selector,'Name');
      fig = selector;
      selector = 'init';
   end;
   figinfo.fig = fig;
   figinfo.oldname = figname;
   figinfo.inverthardcopy = get(fig,'InvertHardcopy');
   figinfo.paperorientation = get(fig,'PaperOrientation');
   figinfo.paperposition = get(fig,'PaperPosition');
   figinfo.manualpaperposition = figinfo.paperposition;
   figinfo.paperpositionmode = get(fig,'PaperPositionMode');
   figinfo.papertype = get(fig,'PaperType');
   figinfo.paperunits = get(fig,'PaperUnits');
   figinfo.papersize = get(fig,'PaperSize');
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   old_figunits = get(fig,'Units');
   set(fig,'Units','pixels');
   figsize = get(fig,'Position');
   set(fig,'Units',old_figunits);
   figinfo.figsize = figsize;
   if (strcmp(get(fig,'Name'),'Preferences')==1)&(strcmp(get(fig,'Tag'),'Preferences')==1);
      pref_visible = 'off';
   else;
      pref_visible = 'on';
   end;
   curr_ini = find_inisettings;
   oldcurr_ini = curr_ini;
   if strcmp(pref_visible,'on')==1;
      add_p_height = 0;
      %
      % check which center values and fill values the graph obeys
      % (only when pagesetup_fcn is run from a figure - not from
      % the preferences dialogue).
      %
      if iscompiled==1;
         toolbar = get(fig,'UserData');
         if isempty(get(toolbar.open,'UserData'))==0;
            curr_ini.crop_image = 1;
         else;
            curr_ini.crop_image = 0;
         end;
         oldcurr_ini.crop_image = curr_ini.crop_image;
      end;
      %
      % check if these defaults have been altered
      %
      paper_position = figinfo.paperposition;
      paper_size = figinfo.papersize;
      %
      % check if lower left, right, upper left or right
      %
      if (strcmp(num2str(paper_position(1),'%0.4f'),num2str((paper_size(1)-paper_position(3))/2,'%0.4f'))==1)&(strcmp(num2str(paper_position(2),'%0.4f'),num2str((paper_size(2)-paper_position(4))/2,'%0.4f'))==1);
         curr_ini.center_value = 1;
      elseif (strcmp(num2str(abs(paper_position(1)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)),'%0.4f'),'0.0000')==1);
         curr_ini.center_value = 2;
      elseif (strcmp(num2str(abs(paper_position(1)-(paper_size(1)-paper_position(3))),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)),'%0.4f'),'0.0000')==1);
         curr_ini.center_value = 3;
      elseif (strcmp(num2str(abs(paper_position(1)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)-(paper_size(2)-paper_position(4))),'%0.4f'),'0.0000')==1);
         curr_ini.center_value = 4;
      elseif (strcmp(num2str(abs(paper_position(1)-(paper_size(1)-paper_position(3))),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)-(paper_size(2)-paper_position(4))),'%0.4f'),'0.0000')==1);
         curr_ini.center_value = 5;
      else;
         curr_ini.center_value = 6;
      end;
      %
      % check if scaled
      %
      if (strcmp(num2str(abs(paper_size(1)-paper_position(3)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_size(2)-paper_position(4)),'%0.4f'),'0.0000')==1);
         curr_ini.fill_value = 1;
      elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/2)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/2)*paper_size(2),'%0.4f'))==1);
         curr_ini.fill_value = 2;
      elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/3)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/3)*paper_size(2),'%0.4f'))==1);
         curr_ini.fill_value = 3;
      elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/4)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/4)*paper_size(2),'%0.4f'))==1);
         curr_ini.fill_value = 4;
      elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/10)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/10)*paper_size(2),'%0.4f'))==1);
         curr_ini.fill_value = 5;
      else;
         curr_ini.fill_value = 6;
      end;
   else;
      add_p_height = 40;
      if isequal(curr_ini.fill_value,6)==0;
         paper_position = figinfo.paperposition;
         paper_size = figinfo.papersize;
         if curr_ini.fill_value==1;
            new_paper_position = [0 0 paper_size];
         elseif curr_ini.fill_value==2;
            new_paper_position = [(1/4)*paper_size (1/2)*paper_size];
         elseif curr_ini.fill_value==3;
            new_paper_position = [(1/3)*paper_size (1/3)*paper_size];
         elseif curr_ini.fill_value==4;
            new_paper_position = [(3/8)*paper_size (1/4)*paper_size];
         elseif curr_ini.fill_value==5;
            new_paper_position = [(9/20)*paper_size (1/10)*paper_size];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
      end;
      if isequal(curr_ini.center_value,6)==0;
         paper_position = figinfo.paperposition;
         paper_size = figinfo.papersize;
         if curr_ini.center_value==1;
            %
            % center graph
            %
            new_left = (paper_size(1)-paper_position(3))/2;
            new_bottom = (paper_size(2)-paper_position(4))/2;
            new_paper_position = [new_left new_bottom paper_position(3:4)];
         elseif curr_ini.center_value==2;
            new_paper_position = [0 0 paper_position(3:4)];
         elseif curr_ini.center_value==3;
            new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
         elseif curr_ini.center_value==4;
            new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
         elseif curr_ini.center_value==5;
            new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
      end;
      if nargin==1;
         oldcurr_ini = '';
      end;
   end;
   %
   % create a shadow figure to determine axes and page positions for page and graph model
   %
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   if strcmp(figinfo.paperorientation,'portrait')==1;
      my_portrait = [1 0];
   else;
      my_portrait = [0 1];
   end;
   if strcmp(figinfo.paperpositionmode,'auto')==1;
      my_paperpositionmode = [1 0];
      axes_callback = '';
      papertype_enable = 'off';
   else;
      my_paperpositionmode = [0 1];
      axes_callback = 'pagesetup_fcn moveaxes';
      papertype_enable = 'on';
   end;
   if strcmp(figinfo.inverthardcopy,'on')==1;
      my_color = [1 0];
   else;
      my_color = [0 1];
   end;
   papertype_str = 'usletter';
   papertype_str = strvcat(papertype_str,'uslegal');
   papertype_str = strvcat(papertype_str,'tabloid');
   papertype_str = strvcat(papertype_str,'A0');
   papertype_str = strvcat(papertype_str,'A1');
   papertype_str = strvcat(papertype_str,'A2');
   papertype_str = strvcat(papertype_str,'A3');
   papertype_str = strvcat(papertype_str,'A4');
   papertype_str = strvcat(papertype_str,'A5');
   papertype_str = strvcat(papertype_str,'B0');
   papertype_str = strvcat(papertype_str,'B1');
   papertype_str = strvcat(papertype_str,'B2');
   papertype_str = strvcat(papertype_str,'B3');
   papertype_str = strvcat(papertype_str,'B4');
   papertype_str = strvcat(papertype_str,'B5');
   papertype_str = strvcat(papertype_str,'arch-A');
   papertype_str = strvcat(papertype_str,'arch-B');
   papertype_str = strvcat(papertype_str,'arch-C');
   papertype_str = strvcat(papertype_str,'arch-D');
   papertype_str = strvcat(papertype_str,'arch-E');
   papertype_str = strvcat(papertype_str,'A');
   papertype_str = strvcat(papertype_str,'B');
   papertype_str = strvcat(papertype_str,'C');
   papertype_str = strvcat(papertype_str,'D');
   papertype_str = strvcat(papertype_str,'E');
   papertype_value = 1;
   for i=1:size(papertype_str,1);
      papertypecheck = strtrim(papertype_str(i,:));
      if strcmp(papertypecheck,figinfo.papertype)==1;
         papertype_value = i;
         break;
      end;
   end;
   if strcmp(figinfo.paperunits,'inches')==1;
      paperunits_value = 1;
   elseif strcmp(figinfo.paperunits,'centimeters')==1;
      paperunits_value = 2;
   elseif strcmp(figinfo.paperunits,'normalized')==1;
      paperunits_value = 3;
   else,
      paperunits_value = 4;
   end;
   my_exit = 1;
   %
   % Set screen size directly instead of using
   % get(0,'ScreenSize')!
   %
   realscrsz = get(0,'ScreenSize');
   curr_ini.myrun = 0;
else;
   my_exit = 0;
   pagesetup_gui = findobj('Type','figure','Tag','PageSetup');
   pagesetup = get(pagesetup_gui,'UserData');
   curr_ini = get(pagesetup.landscape,'UserData');
   oldcurr_ini = curr_ini.oldini;
end;

switch selector
case 'init'
   pagesetup_gui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'FileName','pagesetup_fcn.m', ...
         'MenuBar','none', ...
         'PaperUnits','points', ...
         'Units','pixels', ...
         'Position',[(realscrsz(3)-600)/2 (realscrsz(4)-550)/2 600 550], ...
         'Tag','PageSetup', ...
         'Visible','off', ...
         'Resize','off', ...
         'Name',['Page Setup - ' figname], ...
         'NumberTitle','off', ...
         'DoubleBuffer','on', ...
         'WindowStyle','modal', ...
         'CloseRequestFcn','pagesetup_fcn done', ...
         'ToolBar','none');

   if matlabnumber>=7.0;
      set(pagesetup_gui,'DockControl','off');
   end;

   axesbox([2 2 598 540],'Page Setup Selections',110,[0.5 1]);

   %
   % Display page
   %

   axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4],...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'XLim',[0 1], ...
         'YLim',[0 1], ...
         'Position',[14 300 572 226], ...
         'Visible','on', ...
         'Tag','FrameBack');

   pagesetup.page = axes('Units','pixels', ...
         'Color',[1 1 1],...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'XLim',[0 1], ...
         'YLim',[0 1], ...
         'Position',pagepos, ...
         'UserData','working', ...
         'Visible','on', ...
         'Tag','FrameForward');

   %
   % Orientation
   %

   axesbox([14 206 180 80],'Orientation',55,[0.5 1]);

   pagesetup.portrait = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[30 246 120 20], ...
         'Style','radio', ...
         'Value',my_portrait(1), ...
         'UserData',my_portrait, ...
         'HorizontalAlignment','left', ...
         'String','Portrait', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn portrait', ...
         'Enable','on', ...
         'Tag','portrait');

   pagesetup.landscape = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[30 226 120 20], ...
         'Style','radio', ...
         'Value',my_portrait(2), ...
         'HorizontalAlignment','left', ...
         'String','Landscape', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn portrait', ...
         'Enable','on', ...
         'Tag','landscape');

   %
   % Color printing
   %


   axesbox([14 100 180 94],'Color',25,[0.5 1]);


   uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[30 160 150 20], ...
         'Style','text', ...
         'HorizontalAlignment','left', ...
         'String','Print colored lines and text in:', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Enable','on', ...
         'Tag','ColorText');

   pagesetup.bw = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[30 140 120 20], ...
         'Style','radio', ...
         'Value',my_color(1), ...
         'UserData',my_color, ...
         'HorizontalAlignment','left', ...
         'String','Black and White', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn color', ...
         'Enable','on', ...
         'Tag','on');

   pagesetup.color = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[30 120 120 20], ...
         'Style','radio', ...
         'Value',my_color(2), ...
         'HorizontalAlignment','left', ...
         'String','Color', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn color', ...
         'Enable','on', ...
         'Tag','off');

   %
   % cropping image
   %

   if iscompiled==1;
      pagesetup.cropimage = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'ForegroundColor',[0 0 0], ...
            'Position',[14 70 180 20], ...
            'Style','checkbox', ...
            'Value',curr_ini.crop_image, ...
            'HorizontalAlignment','left', ...
            'String','Crop image for supported file types', ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'FontWeight',curr_ini.gui_fontweight, ...
            'FontAngle',curr_ini.gui_fontangle, ...
            'Callback','pagesetup_fcn crop', ...
            'Enable','on', ...
            'Tag','off');
   end;

   %
   % Size and Position
   %


   axesbox([206 60+add_p_height 380 226-add_p_height],'Size and Position',85,[0.5 1]);


   pagesetup.paperpositionmodeauto = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[222 246 200 20], ...
         'Style','radio', ...
         'Value',my_paperpositionmode(1), ...
         'UserData',my_paperpositionmode, ...
         'HorizontalAlignment','left', ...
         'String','Match figure screen size', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn paperpositionmode', ...
         'Enable','on', ...
         'Tag','auto');


   pagesetup.paperpositionmodemanual = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[222 226 200 20], ...
         'Style','radio', ...
         'Value',my_paperpositionmode(2), ...
         'UserData',figinfo.paperposition, ...
         'HorizontalAlignment','left', ...
         'String','Set manual position and size', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn paperpositionmode', ...
         'Enable','on', ...
         'Tag','manual');

   %
   % paper size and units
   %

   uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[222 181 60 20], ...
         'Style','text', ...
         'HorizontalAlignment','left', ...
         'String','Paper Size:', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Enable','on', ...
         'Tag','PaperSizeText');

   pagesetup.papertype = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'ForegroundColor',[0 0 0], ...
         'Position',[290 186 80 20], ...
         'Style','popup', ...
         'Value',papertype_value, ...
         'HorizontalAlignment','left', ...
         'String',papertype_str, ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn papertype', ...
         'UserData',papertype_value, ...
         'Enable','on', ...
         'Tag','papertype');

   pagesetup.papersizestr = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[370 181 100 20], ...
         'Style','text', ...
         'HorizontalAlignment','right', ...
         'String',paper_size_str, ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Enable','on', ...
         'Tag','PaperSizeString');

   pagesetup.paperunits = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'ForegroundColor',[0 0 0], ...
         'Position',[480 186 90 20], ...
         'Style','popup', ...
         'Value',paperunits_value, ...
         'HorizontalAlignment','left', ...
         'String',strvcat('inches','centimeters','normalized','points'), ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn paperunits', ...
         'UserData',paperunits_value, ...
         'Enable','on', ...
         'Tag','paperunits');

   %
   % Paper position controls
   %

   pagesetup.paperposition = uicontrol('Units','pixels', ...
      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[222 150 348 20], ...
      'FontWeight','bold', ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'Style','text', ...
      'HorizontalAlignment','center', ...
      'Enable',papertype_enable, ...
      'Visible','on', ...
      'String','Paper Position', ...
      'Tag','TextPaperPosition');

   pagesetup.textleft = uicontrol('Units','pixels', ...
      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[222 130 79.5 20], ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','text', ...
      'HorizontalAlignment','center', ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'String','Left:', ...
      'Tag','TextLeft');

   pagesetup.left = uicontrol('Units','pixels', ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'Position',[222 110 79.5 20], ...
      'String',num2str(figinfo.paperposition(1),'%0.4f'), ...
      'UserData',num2str(figinfo.paperposition(1),'%0.4f'), ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','edit', ...
      'Callback','pagesetup_fcn paperposition', ...
      'Tag','1');

   pagesetup.textbottom = uicontrol('Units','pixels', ...
      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[311.5 130 79.5 20], ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','text', ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'HorizontalAlignment','center', ...
      'String','Bottom:', ...
      'Tag','TextLeft');

   pagesetup.bottom = uicontrol('Units','pixels', ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'Position',[311.5 110 79.5 20], ...
      'String',num2str(figinfo.paperposition(2),'%0.4f'), ...
      'UserData',num2str(figinfo.paperposition(2),'%0.4f'), ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','edit', ...
      'Callback','pagesetup_fcn paperposition', ...
      'Tag','2');

   pagesetup.textwidth = uicontrol('Units','pixels', ...
      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[401 130 79.5 20], ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','text', ...
      'HorizontalAlignment','center', ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'String','Width:', ...
      'Tag','TextWidth');

   pagesetup.width = uicontrol('Units','pixels', ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'Position',[401 110 79.5 20], ...
      'String',num2str(figinfo.paperposition(3),'%0.4f'), ...
      'UserData',num2str(figinfo.paperposition(3),'%0.4f'), ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'Style','edit', ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Callback','pagesetup_fcn paperposition', ...
      'Tag','3');

   pagesetup.textheight = uicontrol('Units','pixels', ...
      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[490.5 130 79.5 20], ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Style','text', ...
      'HorizontalAlignment','center', ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'String','Height:', ...
      'Tag','TextHeight');

   pagesetup.height = uicontrol('Units','pixels', ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'Position',[490.5 110 79.5 20], ...
      'String',num2str(figinfo.paperposition(4),'%0.4f'), ...
      'UserData',num2str(figinfo.paperposition(4),'%0.4f'), ...
      'Enable',papertype_enable, ...
      'Visible',pref_visible, ...
      'Style','edit', ...
      'FontSize',curr_ini.gui_fontsize, ...
      'FontName',curr_ini.gui_fontname, ...
      'FontWeight',curr_ini.gui_fontweight, ...
      'FontAngle',curr_ini.gui_fontangle, ...
      'Callback','pagesetup_fcn paperposition', ...
      'Tag','4');

   %
   % buttons to help centering, filling and using max aspects ratio
   %

   pagesetup.center  = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'ForegroundColor',[0 0 0], ...
         'Position',[222 74+add_p_height 169 25], ...
         'Value',curr_ini.center_value, ...
         'String',strvcat('Center position','Lower left position','Lower right position','Upper left position','Upper right position','[Change paper position]'), ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Style','popupmenu', ...
         'UserData',curr_ini.center_value, ...
         'Callback','pagesetup_fcn center', ...
         'Enable',papertype_enable, ...
         'Tag','Center');

   pagesetup.fill = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'ForegroundColor',[0 0 0], ...
         'Position',[401 74+add_p_height 169 25], ...
         'Value',curr_ini.fill_value, ...
         'String',strvcat('Full paper size scale','1/2 paper size scale','1/3 paper size scale','1/4 paper size scale','1/10 paper size scale','[Change figure scale]'), ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Style','popupmenu', ...
         'UserData',curr_ini.fill_value, ...
         'Callback','pagesetup_fcn fill', ...
         'Enable',papertype_enable, ...
         'Tag','Fill');

   pagesetup.maxaspect = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[485 235 85 25], ...
         'String','Max Aspect', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'Callback','pagesetup_fcn maxaspect', ...
         'Enable',papertype_enable, ...
         'Visible',pref_visible, ...
         'Tag','MaxAspect');

   %
   % print image
   %

   pagesetup.icon = axes('Units','pixels', ...
      'Box','on', ...
      'TickLength',[0 0], ...
      'CameraUpVector',[0 1 0], ...
      'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[30 14 50 50], ...
      'XTickLabelMode','manual', ...
      'YTickLabelMode','manual', ...
      'Tag','AxisLogo', ...
      'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'ZColor',get(0,'defaultuicontrolbackgroundcolor'));

   mycons = getstoredimages;
   cu_ini = find_inisettings;
   if cu_ini.use_toolbar_bgcolor==1;
      bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      bgcolor(1) = max(0,bgcolor(1));
      bgcolor(2) = max(0,bgcolor(2));
      bgcolor(3) = max(0,bgcolor(3));
   else;
      bgcolor = get(0,'defaultuicontrolbackgroundcolor');
   end;
   %

   image('CData',mirrorimage(maketrans(mycons.print_big_image,[160 160 164],bgcolor)),'Clipping','off','Parent',pagesetup.icon);

   %
   % save as image
   %

   imageaxes2 = axes('Units','pixels', ...
      'Box','on', ...
      'TickLength',[0 0], ...
      'CameraUpVector',[0 1 0], ...
      'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
      'Position',[120 14 50 50], ...
      'XTickLabelMode','manual', ...
      'YTickLabelMode','manual', ...
      'Tag','AxisLogo', ...
      'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
      'ZColor',get(0,'defaultuicontrolbackgroundcolor'));

   image('CData',mirrorimage(maketrans(mycons.saveas_big_image,[160 160 164],bgcolor)),'Clipping','off','Parent',imageaxes2);

   %
   % Box for moving figure around on paper
   %

   pagesetup.axes = axes('Units','pixels', ...
         'Color',[0.8 0.8 0.8], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'XLim',[0 1], ...
         'YLim',[0 1], ...
         'Position',axespos, ...
         'ButtonDownFcn',axes_callback, ...
         'UserData',figinfo, ...
         'Visible','on', ...
         'Tag','FrameAxes');

   pagesetup.line1 = line('XData',[0 0], ...
         'YData',[0 1], ...
         'Marker','s', ...
         'LineStyle',':', ...
         'MarkerSize',4, ...
         'MarkerEdgeColor',[0 0 0], ...
         'MarkerFaceColor',[0 0 0], ...
         'LineWidth',1);

   pagesetup.line2 = line('XData',[1 1], ...
         'YData',[0 1], ...
         'Marker','s', ...
         'LineStyle',':', ...
         'MarkerSize',4, ...
         'MarkerEdgeColor',[0 0 0], ...
         'MarkerFaceColor',[0 0 0], ...
         'LineWidth',1);

   pagesetup.line3 = line('XData',[0 1], ...
         'YData',[0 0], ...
         'Marker','s', ...
         'LineStyle',':', ...
         'MarkerSize',4, ...
         'MarkerEdgeColor',[0 0 0], ...
         'MarkerFaceColor',[0 0 0], ...
         'LineWidth',1);

   pagesetup.line4 = line('XData',[0 1], ...
         'YData',[1 1], ...
         'Marker','s', ...
         'LineStyle',':', ...
         'MarkerSize',4, ...
         'MarkerEdgeColor',[0 0 0], ...
         'MarkerFaceColor',[0 0 0], ...
         'LineWidth',1);

   %
   % Action controls
   %

   pagesetup.done = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[321 20 85 25], ...
         'String','OK', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'CallBack','pagesetup_fcn done', ...
         'Enable','on', ...
         'UserData','waiting', ...
         'Tag','Done');

   pagesetup.cancel = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[411 20 85 25], ...
         'String','Cancel', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'CallBack','pagesetup_fcn cancel', ...
         'Enable','on', ...
         'UserData',figinfo, ...
         'Tag','Done');

   pagesetup.apply = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ForegroundColor',[0 0 0], ...
         'Position',[501 20 85 25], ...
         'String','Apply', ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'CallBack','pagesetup_fcn apply', ...
         'Enable','off', ...
         'UserData',figinfo, ...
         'Tag','Apply');

   set(pagesetup_gui,'UserData',pagesetup,...
         'HandleVisibility','callback');

case 'crop'
   if isequal(get(pagesetup.cropimage,'Value'),curr_ini.crop_image)==0;
      set(pagesetup.apply,'Enable','on');
   end;
case 'moveaxes'
   if strcmp(get(gcf,'SelectionType'),'normal')==1;
      moveaxis_fcn;
      waitfor(gcf,'Pointer','arrow');
   end;
   pagepos = get(pagesetup.page,'Position');
   axespos = get(pagesetup.axes,'Position');
   new_axespos = axespos;
   if axespos(1)<pagepos(1);
      new_axespos(1) = pagepos(1);
   end;
   if axespos(2)<pagepos(2);
      new_axespos(2) = pagepos(2);
   end;
   if axespos(3)>pagepos(3);
      new_axespos(3) = pagepos(3);
   end;
   if axespos(4)>pagepos(4);
      new_axespos(4) = pagepos(4);
   end;
   if new_axespos(1)+new_axespos(3)>pagepos(1)+pagepos(3);
      new_axespos(1) = pagepos(1)+(pagepos(3)-new_axespos(3));
   end;
   if new_axespos(2)+new_axespos(4)>pagepos(2)+pagepos(4);
      new_axespos(2) = pagepos(2)+(pagepos(4)-new_axespos(4));
   end;
   figinfo = get(pagesetup.axes,'UserData');
   paper_size = figinfo.papersize;
   paper_position = zeros(1,4);
   paper_position(1) = ((new_axespos(1)-pagepos(1))*paper_size(1))/pagepos(3);
   paper_position(2) = ((new_axespos(2)-pagepos(2))*paper_size(2))/pagepos(4);
   paper_position(3) = (new_axespos(3)*paper_size(1))/pagepos(3);
   paper_position(4) = (new_axespos(4)*paper_size(2))/pagepos(4);
   figinfo.paperposition = paper_position;
   figinfo.manualpaperposition = paper_position;
   %
   % check if lower left, right, upper left or right
   %
   if (strcmp(num2str(paper_position(1),'%0.4f'),num2str((paper_size(1)-paper_position(3))/2,'%0.4f'))==1)&(strcmp(num2str(paper_position(2),'%0.4f'),num2str((paper_size(2)-paper_position(4))/2,'%0.4f'))==1);
      set(pagesetup.center,'Value',1);
   elseif (strcmp(num2str(abs(paper_position(1)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)),'%0.4f'),'0.0000')==1);
      set(pagesetup.center,'Value',2);
   elseif (strcmp(num2str(abs(paper_position(1)-(paper_size(1)-paper_position(3))),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)),'%0.4f'),'0.0000')==1);
      set(pagesetup.center,'Value',3);
   elseif (strcmp(num2str(abs(paper_position(1)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)-(paper_size(2)-paper_position(4))),'%0.4f'),'0.0000')==1);
      set(pagesetup.center,'Value',4);
   elseif (strcmp(num2str(abs(paper_position(1)-(paper_size(1)-paper_position(3))),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_position(2)-(paper_size(2)-paper_position(4))),'%0.4f'),'0.0000')==1);
      set(pagesetup.center,'Value',5);
   else;
      set(pagesetup.center,'Value',6);
   end;
   %
   % check if scaled
   %
   if (strcmp(num2str(abs(paper_size(1)-paper_position(3)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_size(2)-paper_position(4)),'%0.4f'),'0.0000')==1);
      set(pagesetup.fill,'Value',1);
   elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/2)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/2)*paper_size(2),'%0.4f'))==1);
      set(pagesetup.fill,'Value',2);
   elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/3)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/3)*paper_size(2),'%0.4f'))==1);
      set(pagesetup.fill,'Value',3);
   elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/4)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/4)*paper_size(2),'%0.4f'))==1);
      set(pagesetup.fill,'Value',4);
   elseif (strcmp(num2str(paper_position(3),'%0.4f'),num2str((1/10)*paper_size(1),'%0.4f'))==1)&(strcmp(num2str(paper_position(4),'%0.4f'),num2str((1/10)*paper_size(2),'%0.4f'))==1);
      set(pagesetup.fill,'Value',5);
   else;
      set(pagesetup.fill,'Value',6);
   end;
   %
   % reset paper position controls
   %
   set(pagesetup.left,'String',num2str(paper_position(1),'%0.4f'),'UserData',num2str(paper_position(1),'%0.4f'));
   set(pagesetup.bottom,'String',num2str(paper_position(2),'%0.4f'),'UserData',num2str(paper_position(2),'%0.4f'));
   set(pagesetup.width,'String',num2str(paper_position(3),'%0.4f'),'UserData',num2str(paper_position(3),'%0.4f'));
   set(pagesetup.height,'String',num2str(paper_position(4),'%0.4f'),'UserData',num2str(paper_position(4),'%0.4f'));
   set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   set(pagesetup.axes,'Position',new_axespos,'UserData',figinfo);
   set(pagesetup.apply,'Enable','on');
   set(pagesetup_gui,'UserData',pagesetup);
case 'paperposition'
   figinfo = get(pagesetup.axes,'UserData');
   this_obj = gcbo;
   new_data = mystr2num(get(this_obj,'String'));
   new_pos = mystr2num(get(this_obj,'Tag'));
   if ((new_data>0)&(new_pos>2))|((new_data>=0)&(new_pos<=2));
      check_data = mystr2num(get(this_obj,'UserData'));
      if strcmp(num2str(check_data),num2str(new_data))==0;
         figinfo = get(pagesetup.axes,'UserData');
         paper_position = figinfo.paperposition;
         paper_position(new_pos) = new_data;
         figinfo.paperposition = paper_position;
         figinfo.manualpaperposition = paper_position;
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
         set(pagesetup.apply,'Enable','on');
      end;
   else;
      set(this_obj,'String',get(this_obj,'UserData'));
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'papertype'
   figinfo = get(pagesetup.axes,'UserData');
   papertype_value = get(pagesetup.papertype,'Value');
   papertype_str = get(pagesetup.papertype,'String');
   paper_type = strtrim(papertype_str(papertype_value,:));
   figinfo.papertype = paper_type;
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   set(pagesetup.papersizestr,'String',paper_size_str);
   set(pagesetup.page,'Position',pagepos);
   set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
   %
   % reset paper position controls
   %
   set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
   set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
   set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
   set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
   if get(pagesetup.paperpositionmodeauto,'Value')==0;
      if isequal(get(pagesetup.fill,'Value'),6)==0;
         %
         % check if figure was filled
         %
         if get(pagesetup.fill,'Value')==1;
            new_paper_position = [0 0 figinfo.papersize];
         %
         % check if figure was half size of paper size
         %
         elseif get(pagesetup.fill,'Value')==2;
            new_paper_position = [(1/4)*figinfo.papersize (1/2)*figinfo.papersize];
         %
         % check if figure was 1/3 of paper size
         %
         elseif get(pagesetup.fill,'Value')==3;
            new_paper_position = [(1/3)*figinfo.papersize (1/3)*figinfo.papersize];
         %
         % check if figure was 1/4 of paper size
         %
         elseif get(pagesetup.fill,'Value')==4;
            new_paper_position = [(3/8)*figinfo.papersize (1/4)*figinfo.papersize];
         %
         % check if figure was 1/10 of paper size
         %
         elseif get(pagesetup.fill,'Value')==5;
            new_paper_position = [(9/20)*figinfo.papersize (1/10)*figinfo.papersize];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
      if isequal(get(pagesetup.center,'Value'),6)==0;
         paper_size = figinfo.papersize;
         paper_position = figinfo.paperposition;
         %
         % check if figure was centered
         %
         if get(pagesetup.center,'Value')==1;
            new_left = (paper_size(1)-paper_position(3))/2;
            new_bottom = (paper_size(2)-paper_position(4))/2;
            new_paper_position = [new_left new_bottom paper_position(3:4)];
         %
         % check if lower left
         %
         elseif get(pagesetup.center,'Value')==2;
            new_paper_position = [0 0 paper_position(3:4)];
         %
         % check if lower right
         %
         elseif get(pagesetup.center,'Value')==3;
            new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
         %
         % check if upper left
         %
         elseif get(pagesetup.center,'Value')==4;
            new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
         %
         % check if upper right
         %
         elseif get(pagesetup.center,'Value')==5;
            new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
      %
      % check to make sure graph fits on paper
      %
      if (figinfo.paperposition(3)>figinfo.papersize(1))|(figinfo.paperposition(4)>figinfo.papersize(2));
         if figinfo.paperposition(3)>figinfo.papersize(1);
            figinfo.paperposition(3)=figinfo.papersize(1);
         end;
         if figinfo.paperposition(4)>figinfo.papersize(2);
            figinfo.paperposition(4)=figinfo.papersize(2);
         end;
         if figinfo.paperposition(1)<0;
            figinfo.paperposition(1)=0;
         end;
         if figinfo.paperposition(2)<0;
            figinfo.paperposition(2)=0;
         end;
         if figinfo.paperposition(1)+figinfo.paperposition(3)>figinfo.papersize(1);
            figinfo.paperposition(1)=0;
         end;
         if figinfo.paperposition(2)+figinfo.paperposition(4)>figinfo.papersize(2);
            figinfo.paperposition(2)=0;
         end;
         %
         % re-center it if selected
         %
         if get(pagesetup.center,'Value')==1;
            figinfo.paperposition(1:2) = (figinfo.papersize-figinfo.paperposition(3:4))/2;
         end;
         figinfo.manualpaperposition = figinfo.paperposition;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
   end;
   if get(pagesetup.paperpositionmodemanual,'Value')==1;
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   end;
   ud = get(pagesetup.papertype,'UserData');
   if isequal(ud,papertype_value)==0;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'paperunits'
   figinfo = get(pagesetup.axes,'UserData');
   paperunits_value = get(pagesetup.paperunits,'Value');
   paperunits_str = get(pagesetup.paperunits,'String');
   paper_units = strtrim(paperunits_str(paperunits_value,:));
   figinfo.manualpaperunits = paper_units;
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   set(pagesetup.papersizestr,'String',paper_size_str);
   set(pagesetup.axes,'UserData',figinfo);
   %
   % reset paper position controls
   %
   set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
   set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
   set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
   set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
   if get(pagesetup.paperpositionmodemanual,'Value')==1;
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   end;
   ud = get(pagesetup.paperunits,'Userdata');
   if isequal(ud,paper_units)==0;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'paperpositionmode'
   figinfo = get(pagesetup.axes,'UserData');
   %
   % create a new figure with same properties
   % but which is hidden
   %
   p_tag = get(gcbo,'Tag');
   figinfo.paperpositionmode = p_tag;
   if get(pagesetup.paperpositionmodemanual,'Value')==1;
      figinfo.paperposition = get(pagesetup.paperpositionmodemanual,'UserData');
      figinfo.manualpaperposition = get(pagesetup.paperpositionmodemanual,'UserData');
   end;
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   if strcmp(p_tag,'auto')==1;
      my_paperpositionmode = [1 0];
      axes_callback = '';
      set(pagesetup.line1,'Marker','none');
      set(pagesetup.line2,'Marker','none');
      set(pagesetup.line3,'Marker','none');
      set(pagesetup.line4,'Marker','none');
      papertype_enable = 'off';
      set(pagesetup.center,'UserData',get(pagesetup.center,'Value'));
      set(pagesetup.fill,'UserData',get(pagesetup.fill,'Value'));
      curr_ini.center_value = 6;
      curr_ini.fill_value = 6;
   else;
      my_paperpositionmode = [0 1];
      axes_callback = 'pagesetup_fcn moveaxes';
      set(pagesetup.line1,'Marker','s');
      set(pagesetup.line2,'Marker','s');
      set(pagesetup.line3,'Marker','s');
      set(pagesetup.line4,'Marker','s');
      papertype_enable = 'on';
      curr_ini.center_value = get(pagesetup.center,'UserData');
      curr_ini.fill_value = get(pagesetup.fill,'UserData');
   end;
   ud = get(pagesetup.paperpositionmodeauto,'UserData');
   set(pagesetup.paperpositionmodeauto,'Value',my_paperpositionmode(1),'UserData',my_paperpositionmode);
   set(pagesetup.paperpositionmodemanual,'Value',my_paperpositionmode(2));
   set(pagesetup.page,'Position',pagepos);
   set(pagesetup.axes,'Position',axespos,'UserData',figinfo,'ButtonDownFcn',axes_callback);
   %
   % reset paper position controls
   %
   set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
   set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
   set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
   set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
   set(pagesetup.center,'Enable',papertype_enable,'Value',curr_ini.center_value);
   set(pagesetup.fill,'Enable',papertype_enable,'Value',curr_ini.fill_value);
   set(pagesetup.maxaspect,'Enable',papertype_enable);
   if isequal(ud,my_paperpositionmode)==0;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'color'
   figinfo = get(pagesetup.axes,'UserData');
   p_tag = get(gcbo,'Tag');
   if strcmp(p_tag,'on')==1;
      my_color = [1 0];
   else;
      my_color = [0 1];
   end;
   figinfo.inverthardcopy = p_tag;
   set(pagesetup.axes,'UserData',figinfo);
   set(pagesetup.bw,'Value',my_color(1));
   set(pagesetup.color,'Value',my_color(2));
   ud = get(pagesetup.bw,'UserData');
   if strcmp(num2str(my_color),num2str(ud))==0;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'fill'
   figinfo = get(pagesetup.axes,'UserData');
   old_axespos = get(pagesetup.axes,'Position');
   old_pagepos = get(pagesetup.page,'Position');
   if isequal(get(gcbo,'Value'),6)==0;
      if get(gcbo,'Value')==1;
         new_paper_position = [0 0 figinfo.papersize];
      elseif get(gcbo,'Value')==2;
         new_paper_position = [(1/4)*figinfo.papersize (1/2)*figinfo.papersize];
      elseif get(gcbo,'Value')==3;
         new_paper_position = [(1/3)*figinfo.papersize (1/3)*figinfo.papersize];
      elseif get(gcbo,'Value')==4;
         new_paper_position = [(3/8)*figinfo.papersize (1/4)*figinfo.papersize];
      elseif get(gcbo,'Value')==5;
         new_paper_position = [(9/20)*figinfo.papersize (1/10)*figinfo.papersize];
      end;
      figinfo.paperposition = new_paper_position;
      figinfo.manualpaperposition = new_paper_position;
      %
      % fix the display
      %
      [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
      set(pagesetup.page,'Position',pagepos);
      set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
      set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
      set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
      set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
      set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      if isequal(get(pagesetup.center,'Value'),6)==0;
         paper_size = figinfo.papersize;
         paper_position = figinfo.paperposition;
         %
         % check if figure was centered
         %
         if get(pagesetup.center,'Value')==1;
            new_left = (paper_size(1)-paper_position(3))/2;
            new_bottom = (paper_size(2)-paper_position(4))/2;
            new_paper_position = [new_left new_bottom paper_position(3:4)];
         %
         % check if lower left
         %
         elseif get(pagesetup.center,'Value')==2;
            new_paper_position = [0 0 paper_position(3:4)];
         %
         % check if lower right
         %
         elseif get(pagesetup.center,'Value')==3;
            new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
         %
         % check if upper left
         %
         elseif get(pagesetup.center,'Value')==4;
            new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
         %
         % check if upper right
         %
         elseif get(pagesetup.center,'Value')==5;
            new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);
         set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
      set(pagesetup.apply,'Enable','on');
   else;
      oldfiginfo = get(pagesetup.cancel,'UserData');
      if strcmp(num2str(max(abs(oldfiginfo.paperposition-figinfo.paperposition)),'%0.4f'),'0.0000')==0;
         figinfo.paperposition = oldfiginfo.paperposition;
         figinfo.manualpaperposition = oldfiginfo.paperposition;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
         set(pagesetup.apply,'Enable','on');
         set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
      end;
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'center'
   figinfo = get(pagesetup.axes,'UserData');
   old_axespos = get(pagesetup.axes,'Position');
   old_pagepos = get(pagesetup.page,'Position');
   if isequal(get(gcbo,'Value'),6)==0;
      paper_size = figinfo.papersize;
      paper_position = figinfo.paperposition;
      if get(gcbo,'Value')==1;
         %
         % center graph
         %
         new_left = (paper_size(1)-paper_position(3))/2;
         new_bottom = (paper_size(2)-paper_position(4))/2;
         new_paper_position = [new_left new_bottom paper_position(3:4)];
      elseif get(gcbo,'Value')==2;
         new_paper_position = [0 0 paper_position(3:4)];
      elseif get(gcbo,'Value')==3;
         new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
      elseif get(gcbo,'Value')==4;
         new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
      elseif get(gcbo,'Value')==5;
         new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
      end;
      figinfo.paperposition = new_paper_position;
      figinfo.manualpaperposition = new_paper_position;
      %
      % fix the display
      %
      [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
      set(pagesetup.page,'Position',pagepos);
      set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
      set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
      set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
      set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
      set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      set(pagesetup.apply,'Enable','on');
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   else;
      oldfiginfo = get(pagesetup.cancel,'UserData');
      if strcmp(num2str(max(abs(oldfiginfo.paperposition-figinfo.paperposition)),'%0.4f'),'0.0000')==0;
         figinfo.paperposition = oldfiginfo.paperposition;
         figinfo.manualpaperposition = oldfiginfo.paperposition;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
         set(pagesetup.apply,'Enable','on');
         set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
      end;
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'maxaspect'
   figinfo = get(pagesetup.axes,'UserData');
   paper_orientation = figinfo.paperorientation;
   paper_position = figinfo.paperposition;
   paper_size = figinfo.papersize;
   aspect_ratio = paper_position(3)/paper_position(4);
   if aspect_ratio<=(paper_size(1)/paper_size(2));
      new_bottom = 0;
      new_height = paper_size(2);
      new_width = new_height*aspect_ratio;
      new_left = (paper_size(1)-new_width)/2;
   else;
      new_left = 0;
      new_width = paper_size(1);
      new_height = new_width/aspect_ratio;
      new_bottom = (paper_size(2)-new_height)/2;
   end;
   new_paper_position = [new_left new_bottom new_width new_height];
   if strcmp(num2str(paper_position),num2str(new_paper_position))==0;
      figinfo.paperposition = new_paper_position;
      figinfo.manualpaperposition = new_paper_position;
      %
      % fix the display
      %
      [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
      set(pagesetup.page,'Position',pagepos);
      set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
      set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
      set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
      set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
      set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      set(pagesetup.center,'Value',1);
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
      %
      % reset centering and fill controls
      %
      set(pagesetup.center,'Value',1);
      if (strcmp(num2str(abs(paper_size(1)-new_paper_position(3)),'%0.4f'),'0.0000')==1)&(strcmp(num2str(abs(paper_size(2)-new_paper_position(4)),'%0.4f'),'0.0000')==1);
         set(pagesetup.fill,'Value',1);
      else;
         set(pagesetup.fill,'Value',6);
      end;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'portrait'
   figinfo = get(pagesetup.axes,'UserData');
   p_tag = get(gcbo,'Tag');
   figinfo.paperorientation = p_tag;
   if strcmp(p_tag,'portrait')==1;
      my_portrait = [1 0];
   else;
      my_portrait = [0 1];
   end;
   ud = get(pagesetup.portrait,'UserData');
   set(pagesetup.portrait,'Value',my_portrait(1),'UserData',my_portrait);
   set(pagesetup.landscape,'Value',my_portrait(2));
   %
   % fix the display
   %
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
   set(pagesetup.page,'Position',pagepos);
   set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
   if get(pagesetup.paperpositionmodeauto,'Value')==0;
      if isequal(get(pagesetup.fill,'Value'),6)==0;
         %
         % check if figure was filled
         %
         if get(pagesetup.fill,'Value')==1;
            new_paper_position = [0 0 figinfo.papersize];
         %
         % check if figure was half size of paper size
         %
         elseif get(pagesetup.fill,'Value')==2;
            new_paper_position = [(1/4)*figinfo.papersize (1/2)*figinfo.papersize];
         %
         % check if figure was 1/3 of paper size
         %
         elseif get(pagesetup.fill,'Value')==3;
            new_paper_position = [(1/3)*figinfo.papersize (1/3)*figinfo.papersize];
         %
         % check if figure was 1/4 of paper size
         %
         elseif get(pagesetup.fill,'Value')==4;
            new_paper_position = [(3/8)*figinfo.papersize (1/4)*figinfo.papersize];
         %
         % check if figure was 1/10 of paper size
         %
         elseif get(pagesetup.fill,'Value')==5;
            new_paper_position = [(9/20)*figinfo.papersize (1/10)*figinfo.papersize];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
      if isequal(get(pagesetup.center,'Value'),6)==0;
         paper_size = figinfo.papersize;
         paper_position = figinfo.paperposition;
         %
         % check if figure was centered
         %
         if get(pagesetup.center,'Value')==1;
            new_left = (paper_size(1)-paper_position(3))/2;
            new_bottom = (paper_size(2)-paper_position(4))/2;
            new_paper_position = [new_left new_bottom paper_position(3:4)];
         %
         % check if lower left
         %
         elseif get(pagesetup.center,'Value')==2;
            new_paper_position = [0 0 paper_position(3:4)];
         %
         % check if lower right
         %
         elseif get(pagesetup.center,'Value')==3;
            new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
         %
         % check if upper left
         %
         elseif get(pagesetup.center,'Value')==4;
            new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
         %
         % check if upper right
         %
         elseif get(pagesetup.center,'Value')==5;
            new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
         end;
         figinfo.paperposition = new_paper_position;
         figinfo.manualpaperposition = new_paper_position;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
      %
      % check to make sure graph fits on paper
      %
      if (figinfo.paperposition(3)>figinfo.papersize(1))|(figinfo.paperposition(4)>figinfo.papersize(2));
         if figinfo.paperposition(3)>figinfo.papersize(1);
            figinfo.paperposition(3)=figinfo.papersize(1);
         end;
         if figinfo.paperposition(4)>figinfo.papersize(2);
            figinfo.paperposition(4)=figinfo.papersize(2);
         end;
         if figinfo.paperposition(1)<0;
            figinfo.paperposition(1)=0;
         end;
         if figinfo.paperposition(2)<0;
            figinfo.paperposition(2)=0;
         end;
         if figinfo.paperposition(1)+figinfo.paperposition(3)>figinfo.papersize(1);
            figinfo.paperposition(1)=0;
         end;
         if figinfo.paperposition(2)+figinfo.paperposition(4)>figinfo.papersize(2);
            figinfo.paperposition(2)=0;
         end;
         %
         % re-center it if selected
         %
         if get(pagesetup.center,'Value')==1;
            figinfo.paperposition(1:2) = (figinfo.papersize-figinfo.paperposition(3:4))/2;
         end;
         figinfo.manualpaperposition = figinfo.paperposition;
         %
         % fix the display
         %
         [pagepos,axespos,figinfo] = shadow_figure(figinfo);;
         set(pagesetup.page,'Position',pagepos);
         set(pagesetup.axes,'Position',axespos,'UserData',figinfo);
         set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
         set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
         set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
         set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
      end;
   end;
   if get(pagesetup.paperpositionmodemanual,'Value')==1;
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   end;
   if strcmp(num2str(ud),num2str(my_portrait))==0;
      set(pagesetup.apply,'Enable','on');
   end;
   set(pagesetup_gui,'UserData',pagesetup);
case 'cancel'
   figinfo = get(pagesetup.cancel,'UserData');
   set(pagesetup.apply,'UserData',figinfo,'Enable','off');
   %
   % restore controls
   %
   [pagepos,axespos] = shadow_figure(figinfo);
   set(pagesetup.page,'Position',pagepos);
   if strcmp(figinfo.paperpositionmode,'auto')==1;
      my_paperpositionmode = [1 0];
      axes_callback = '';
   else;
      my_paperpositionmode = [0 1];
      axes_callback = 'pagesetup_fcn moveaxes';
   end;
   set(pagesetup.paperpositionmodeauto,'Value',my_paperpositionmode(1),'UserData',my_paperpositionmode);
   set(pagesetup.paperpositionmodemanual,'Value',my_paperpositionmode(2));
   set(pagesetup.axes,'Position',axespos,'UserData',figinfo,'ButtonDownFcn',axes_callback);
   if strcmp(figinfo.paperorientation,'portrait')==1;
      my_portrait = [1 0];
   else;
      my_portrait = [0 1];
   end;
   set(pagesetup.portrait,'Value',my_portrait(1),'UserData',my_portrait);
   set(pagesetup.landscape,'Value',my_portrait(2));
   if iscompiled==1;
      set(pagesetup.cropimage,'Value',oldcurr_ini.crop_image);
   end;
   if strcmp(figinfo.inverthardcopy,'on')==1;
      my_color = [1 0];
   else;
      my_color = [0 1];
   end;
   set(pagesetup.bw,'Value',my_color(1),'UserData',my_color);
   set(pagesetup.color,'Value',my_color(2));
   if strcmp(figinfo.paperpositionmode,'auto')==1;
      set(pagesetup.line1,'Marker','none');
      set(pagesetup.line2,'Marker','none');
      set(pagesetup.line3,'Marker','none');
      set(pagesetup.line4,'Marker','none');
      papertype_enable = 'off';
      curr_ini.center_value = 6;
      curr_ini.fill_value = 6;
   else;
      set(pagesetup.line1,'Marker','s');
      set(pagesetup.line2,'Marker','s');
      set(pagesetup.line3,'Marker','s');
      set(pagesetup.line4,'Marker','s');
      papertype_enable = 'on';
      curr_ini.center_value = get(pagesetup.center,'UserData');
      curr_ini.fill_value = get(pagesetup.fill,'UserData');
      set(pagesetup.paperpositionmodemanual,'UserData',figinfo.paperposition);
   end;
   set(pagesetup.left,'String',num2str(figinfo.paperposition(1),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(1),'%0.4f'));
   set(pagesetup.bottom,'String',num2str(figinfo.paperposition(2),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(2),'%0.4f'));
   set(pagesetup.width,'String',num2str(figinfo.paperposition(3),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(3),'%0.4f'));
   set(pagesetup.height,'String',num2str(figinfo.paperposition(4),'%0.4f'),'Enable',papertype_enable,'UserData',num2str(figinfo.paperposition(4),'%0.4f'));
   set(pagesetup.center,'Enable',papertype_enable,'Value',curr_ini.center_value,'UserData',curr_ini.center_value);
   set(pagesetup.fill,'Enable',papertype_enable,'Value',curr_ini.fill_value,'UserData',curr_ini.fill_value);
   set(pagesetup.maxaspect,'Enable',papertype_enable);
   papertype_str = get(pagesetup.papertype,'String');
   papertype_value = 1;
   for i=1:size(papertype_str,1);
      papertypecheck = strtrim(papertype_str(i,:));
      if strcmp(papertypecheck,figinfo.papertype)==1;
         papertype_value = i;
         break;
      end;
   end;
   set(pagesetup.papertype,'Value',papertype_value);
   if strcmp(figinfo.paperunits,'inches')==1;
      paperunits_value = 1;
   elseif strcmp(figinfo.paperunits,'centimeters')==1;
      paperunits_value = 2;
   elseif strcmp(figinfo.paperunits,'normalized')==1;
      paperunits_value = 3;
   else,
      paperunits_value = 4;
   end;
   set(pagesetup.paperunits,'Value',paperunits_value);
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   set(pagesetup.papersizestr,'String',paper_size_str);
   set(pagesetup_gui,'UserData',pagesetup);
case 'apply'
   if curr_ini.myrun==0;
      curr_ini.myrun = 1;
      figinfo = get(pagesetup.axes,'UserData');
      set(pagesetup.bw,'UserData',[get(pagesetup.bw,'Value') get(pagesetup.color,'Value')]);
      if iscompiled==1;
         curr_ini.crop_image = get(pagesetup.cropimage,'Value');
      end;
      set(pagesetup.apply,'UserData',figinfo,'Enable','off');
      curr_ini.myrun = 0;
   end;
case 'done'
   if curr_ini.myrun==0;
      set(pagesetup.done,'UserData','done');
%      if strcmp(get(pagesetup.page,'UserData'),'done')==1;
%         delete(pagesetup_gui);
%      end;
   end;
end;

if nargout==1;
   h = pagesetup_gui;
end;

if strcmp(selector,'init')==1;
   if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadguiicon==1);
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(pagesetup_gui,'Name') ' ' fix_filepath([pwd '\icons\pagesetup.ico'])];
      dos(prog);
      if (strcmp(curr_ini.pstoolsdir,'')==0)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
         %
         % now we need to determine the pid
         %
         pid = getpid('seticon');
         set(pagesetup.icon,'UserData',pid);
      end;
   end;
   set(pagesetup_gui,'Visible','on');
   drawnow;
   if (iswinnt==1)&(iscompiled==1)&(matlabnumber<7);
      drawnow;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(pagesetup_gui,'Name') ' 3'];
      dos(prog);
      drawnow;
   elseif matlabnumber>=7;
      uicontrol(pagesetup.done);
   end;
end;

if strcmp(selector,'done')==0;
   curr_ini.oldini = oldcurr_ini;
   set(pagesetup.landscape,'UserData',curr_ini);
end;

if my_exit==1;
   waitfor(pagesetup.done,'UserData','done');
end;

%
% end of pagesetup_fcn.m
%

