function paste_patch_fcn

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');
if isempty(copy)==0;
   if isfield(copy,'patch_properties')==1;
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         old_xlim = get(gca,'XLim');
         copy_xlim = [min(min(copy.patch_properties.xdata)) max(max(copy.patch_properties.xdata))];
         if old_xlim==[0 1];
            new_xlim = copy_xlim;
         else;
            new_xlim = [min(old_xlim(1),copy_xlim(1)) max(old_xlim(2),copy_xlim(2))];
         end;
         if new_xlim(1)==new_xlim(2);
            new_xlim = [new_xlim(1)-0.1 new_xlim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         old_ylim = get(gca,'YLim');
         copy_ylim = [min(min(copy.patch_properties.ydata)) max(max(copy.patch_properties.ydata))];
         if old_ylim==[0 1];
            new_ylim = copy_ylim;
         else;
            new_ylim = [min(old_ylim(1),copy_ylim(1)) max(old_ylim(2),copy_ylim(2))];
         end;
         if new_ylim(1)==new_ylim(2);
            new_ylim = [new_ylim(1)-0.1 new_ylim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         old_zlim = get(gca,'ZLim');
         if isempty(copy.patch_properties.zdata)==0;
            copy_zlim = [min(min(copy.patch_properties.zdata)) max(max(copy.patch_properties.zdata))];
            if old_zlim==[0 1];
               new_zlim = copy_zlim;
            else;
               new_zlim = [min(old_zlim(1),copy_zlim(1)) max(old_zlim(2),copy_zlim(2))];
            end;
         else;
            new_zlim = old_zlim;
         end;
         if new_zlim(1)==new_zlim(2);
            new_zlim = [new_zlim(1)-0.1 new_zlim(2)+0.1];
         end;
      end;
      %
      if strcmp(lower(copy.patch_properties.tag),'rectpatch')==1;
         new_tag = copy.patch_properties.tag;
      else;
         new_tag = [copy.patch_properties.tag '-new'];
      end;
      %
      % create a new patch
      %
      this_patch = patch('XData',copy.patch_properties.xdata, ...
         'YData',copy.patch_properties.ydata, ...
         'ZData',copy.patch_properties.zdata, ...
         'CData',copy.patch_properties.cdata, ...
         'CDataMapping',copy.patch_properties.cdatamapping, ...
         'AmbientStrength',copy.patch_properties.ambientstrength, ...
         'BackFaceLighting',copy.patch_properties.backfacelighting, ...
         'DiffuseStrength',copy.patch_properties.diffusestrength, ...
         'EdgeLighting',copy.patch_properties.edgelighting, ...
         'FaceLighting',copy.patch_properties.facelighting, ...
         'SpecularColorReflectance',copy.patch_properties.specularcolorreflectance, ...
         'SpecularExponent',copy.patch_properties.specularexponent, ...
         'SpecularStrength',copy.patch_properties.specularstrength, ...
         'Clipping',copy.patch_properties.clipping, ...
         'FaceColor',copy.patch_properties.facecolor, ...
         'EdgeColor',copy.patch_properties.edgecolor, ...
         'LineStyle',copy.patch_properties.linestyle, ...
         'LineWidth',copy.patch_properties.linewidth, ...
         'Marker',copy.patch_properties.marker, ...
         'MarkerSize',copy.patch_properties.markersize, ...
         'MarkerEdgeColor',copy.patch_properties.markeredgecolor, ...
         'MarkerFaceColor',copy.patch_properties.markerfacecolor, ...
         'Tag',new_tag);
      %
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         set(gca,'XLim',new_xlim);
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         set(gca,'YLim',new_ylim);
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         set(gca,'ZLim',new_zlim);
      end;
      %
      curr_ini = find_inisettings;
      if curr_ini.ytick==1;
         fixytix(gca);
      end;
      if curr_ini.xtick==1;
         fixxtix(gca);
      end;
      %
      % create a context menu for patches
      %
      patches_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',patches_context_menu,'Label','Patch Color','Callback','patch_color_fcn');
      uimenu('Parent',patches_context_menu,'Label','Edge Color','Callback','patch_edgecolor_fcn');
      uimenu('Parent',patches_context_menu,'Label','Face Color','Callback','patch_facecolor_fcn');
      if strcmp(get(this_patch,'LineStyle'),'-')==1;
         solidon = 'on';
      else;
         solidon = 'off';
      end;
      if strcmp(get(this_patch,'LineStyle'),'--')==1;
         dashon = 'on';
      else;
         dashon = 'off';
      end;
      if strcmp(get(this_patch,'LineStyle'),':')==1;
         doton = 'on';
      else;
         doton = 'off';
      end;
      if strcmp(get(this_patch,'LineStyle'),'-.')==1;
         dashdoton = 'on';
      else;
         dashdoton = 'off';
      end;
      patch_type_menu = uimenu('Parent',patches_context_menu,'Separator','on','Label','Type');
         uimenu('Parent',patch_type_menu,'Label','Solid','Checked',solidon,'Callback','change_patch_type(''-''); uimenu_check_fcn');
         uimenu('Parent',patch_type_menu,'Label','Dash','Checked',dashon,'Callback','change_patch_type(''--''); uimenu_check_fcn');
         uimenu('Parent',patch_type_menu,'Label','Dot','Checked',doton,'Callback','change_patch_type('':''); uimenu_check_fcn');
         uimenu('Parent',patch_type_menu,'Label','Dash-Dot','Checked',dashdoton,'Callback','change_patch_type(''-.''); uimenu_check_fcn');
      pt1 = 'off';
      pt2 = 'off';
      pt3 = 'off';
      pt4 = 'off';
      pt5 = 'off';
      pt6 = 'off';
      pt7 = 'off';
      pt8 = 'off';
      pt9 = 'off';
      pt10 = 'off';
      if get(this_patch,'LineWidth')==1;
         pt1 = 'on';
      elseif get(this_patch,'LineWidth')==2;
         pt2 = 'on';
      elseif get(this_patch,'LineWidth')==3;
         pt3 = 'on';
      elseif get(this_patch,'LineWidth')==4;
         pt4 = 'on';
      elseif get(this_patch,'LineWidth')==5;
         pt5 = 'on';
      elseif get(this_patch,'LineWidth')==6;
         pt6 = 'on';
      elseif get(this_patch,'LineWidth')==7;
         pt7 = 'on';
      elseif get(this_patch,'LineWidth')==8;
         pt8 = 'on';
      elseif get(this_patch,'LineWidth')==9;
         pt9 = 'on';
      elseif get(this_patch,'LineWidth')==10;
         pt10 = 'on';
      end;
      patch_width_menu = uimenu('Parent',patches_context_menu,'Label','Width');
         uimenu('Parent',patch_width_menu,'Label','1 pt','Checked',pt1,'Callback','change_patch_width(1); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','2 pts','Checked',pt2,'Callback','change_patch_width(2); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','3 pts','Checked',pt3,'Callback','change_patch_width(3); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','4 pts','Checked',pt4,'Callback','change_patch_width(4); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','5 pts','Checked',pt5,'Callback','change_patch_width(5); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','6 pts','Checked',pt6,'Callback','change_patch_width(6); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','7 pts','Checked',pt7,'Callback','change_patch_width(7); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','8 pts','Checked',pt8,'Callback','change_patch_width(8); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','9 pts','Checked',pt9,'Callback','change_patch_width(9); uimenu_check_fcn');
         uimenu('Parent',patch_width_menu,'Label','10 pts','Checked',pt10,'Callback','change_patch_width(10); uimenu_check_fcn');
      if strcmp(lower(new_tag),'rectpatch')==1;
         uimenu('Parent',patches_context_menu,'Separator','on','Label','Stretch Horizontally','Callback','stretch_a_patch(''h'')');
         uimenu('Parent',patches_context_menu,'Label','Stretch Vertically','Callback','stretch_a_patch(''v'')');
         uimenu('Parent',patches_context_menu,'Label','Adjust X-scale to X axis limits','Callback','xscale_patch_fcn');
         uimenu('Parent',patches_context_menu,'Label','Adjust Y-scale to Y axis limits','Callback','yscale_patch_fcn');
      else;
         nudge_menu = uimenu('Parent',patches_context_menu,'Label','Nudge','Separator','on');
            uimenu('Parent',nudge_menu,'Label','Up','Callback','nudge_fcn(''u'')');
            uimenu('Parent',nudge_menu,'Label','Down','Callback','nudge_fcn(''d'')');
            uimenu('Parent',nudge_menu,'Label','Left','Callback','nudge_fcn(''l'')');
            uimenu('Parent',nudge_menu,'Label','Right','Callback','nudge_fcn(''r'')');
         rescale_menu = uimenu('Parent',patches_context_menu,'Label','Rescale');
            uimenu('Parent',rescale_menu,'Label','10%','Callback','rescale_patch_fcn(0.1)');
            uimenu('Parent',rescale_menu,'Label','20%','Callback','rescale_patch_fcn(0.2)');
            uimenu('Parent',rescale_menu,'Label','25%','Callback','rescale_patch_fcn(0.25)');
            uimenu('Parent',rescale_menu,'Label','30%','Callback','rescale_patch_fcn(0.3)');
            uimenu('Parent',rescale_menu,'Label','40%','Callback','rescale_patch_fcn(0.4)');
            uimenu('Parent',rescale_menu,'Label','50%','Callback','rescale_patch_fcn(0.5)');
            uimenu('Parent',rescale_menu,'Label','60%','Callback','rescale_patch_fcn(0.6)');
            uimenu('Parent',rescale_menu,'Label','70%','Callback','rescale_patch_fcn(0.7)');
            uimenu('Parent',rescale_menu,'Label','75%','Callback','rescale_patch_fcn(0.75)');
            uimenu('Parent',rescale_menu,'Label','80%','Callback','rescale_patch_fcn(0.8)');
            uimenu('Parent',rescale_menu,'Label','90%','Callback','rescale_patch_fcn(0.9)');
            uimenu('Parent',rescale_menu,'Label','110%','Callback','rescale_patch_fcn(1.1)');
            uimenu('Parent',rescale_menu,'Label','120%','Callback','rescale_patch_fcn(1.2)');
            uimenu('Parent',rescale_menu,'Label','125%','Callback','rescale_patch_fcn(1.25)');
            uimenu('Parent',rescale_menu,'Label','130%','Callback','rescale_patch_fcn(1.3)');
            uimenu('Parent',rescale_menu,'Label','140%','Callback','rescale_patch_fcn(1.4)');
            uimenu('Parent',rescale_menu,'Label','150%','Callback','rescale_patch_fcn(1.5)');
            uimenu('Parent',rescale_menu,'Label','160%','Callback','rescale_patch_fcn(1.6)');
            uimenu('Parent',rescale_menu,'Label','170%','Callback','rescale_patch_fcn(1.7)');
            uimenu('Parent',rescale_menu,'Label','180%','Callback','rescale_patch_fcn(1.8)');
            uimenu('Parent',rescale_menu,'Label','190%','Callback','rescale_patch_fcn(1.9)');
            uimenu('Parent',rescale_menu,'Label','200%','Callback','rescale_patch_fcn(2.0)');
            uimenu('Parent',rescale_menu,'Label','250%','Callback','rescale_patch_fcn(2.5)');
            uimenu('Parent',rescale_menu,'Label','300%','Callback','rescale_patch_fcn(3.0)');
            uimenu('Parent',rescale_menu,'Label','400%','Callback','rescale_patch_fcn(4.0)');
            uimenu('Parent',rescale_menu,'Label','500%','Callback','rescale_patch_fcn(5.0)');
            uimenu('Parent',rescale_menu,'Label','1000%','Callback','rescale_patch_fcn(10.0)');
      end;
      uimenu('Parent',patches_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
      if isvalidpatchname(this_patch)==1;
         uimenu('Parent',patches_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
      end;
      uimenu('Parent',patches_context_menu,'Label','Cut','Separator','on','Callback','delete_line_patch_fcn');
      uimenu('Parent',patches_context_menu,'Label','Copy','Callback','copy_patch_fcn');
      set(this_patch,'UIContextMenu',patches_context_menu);
      %
      if strcmp(lower(copy.patch_properties.tag),'rectpatch')==1;
         %
         % set patch below all other objects in current axes
         %
         kids = get(gca,'Children');
         if size(kids,1)>1;
            kids = [kids(2:size(kids,1),1);this_patch];
            set(gca,'Children',kids);
         end;
         %
         % fix layer of axes
         %
         set(gca,'Layer','top');
      end;
      %
      if isempty(get(gca,'UserData'))==0;
         if ishandle(get(gca,'UserData'))==1;
            update_legend_fcn;
         end;
      end;
      %
      % update the axes context menu
      %
      create_axes_contextmenu_fcn;
   else;
      my_text = 'You must copy a patch before you can paste it!';
      about(my_text,'information','Bad paste operation...',120,400);
   end;
else;
   my_text = 'You must copy a patch before you can paste it!';
   about(my_text,'information','Bad paste operation...',120,400);
end;


%
% end of paste_patch_fcn.m
%
