function print_gctest(tm,curr_ini,beta,alpha,Psi,epsilon,Sigma_theta,beta_df,alpha_df,local_df,aind)

c_ind = 0;
if size(tm.restrict,2)==3;
   c_ind = tm.restrict(1,3);
end;
fout = fopen(tm.outputfile,'at');
%
[results,dfmat] = waldgctest(Psi,alpha,beta,tm.p,tm.pe,epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,local_df,aind,tm.modelsdir,tm.modelfile,Sigma_theta,c_ind);
%
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Granger causality tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{Wald-type test statistic}\n');
   sumnk = 0;
   for i=1:tm.n;
      vari = strrep(tm.myvars(i,:),' ','');
      fprintf(fout,'\n\\begin{tabular}{rrrr}\n');
      fprintf(fout,'$H_0$: & \\multicolumn{3}{l}{variable $k$ is Granger noncausal for %s} \\\\\n',txt2ltxmath(vari));
      fprintf(fout,'$H_A$: & \\multicolumn{3}{l}{variable $k$ is Granger causal for %s} \\\\[2mm]\n',txt2ltxmath(vari));
      if curr_ini.sscorrect==0;
         fprintf(fout,'$k$ & W & df & $p$-value \\\\\n');
      else;
         fprintf(fout,'$k$ & F & df & $p$-value \\\\\n');
      end;
      for k=1:tm.n;
         if isequal(i,k)==0;
            sumnk = sumnk+1;
            vark = tm.myvars(k,:);
            if curr_ini.sscorrect==0;
               if dfmat(sumnk,1)>0;
                  fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(vark),results(sumnk,1),dfmat(sumnk,1),results(sumnk,2));
               else;
                  fprintf(fout,'%s & \\multicolumn{3}{l}{Not computed} \\\\\n',txt2ltxmath(vark));
               end;
            else;
               if dfmat(sumnk,1)>0;
                  fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(vark),results(sumnk,1),dfmat(sumnk,1),dfmat(sumnk,2),results(sumnk,2));
               else;
                  fprintf(fout,'%s & \\multicolumn{3}{l}{Not computed} \\\\\n',txt2ltxmath(vark));
               end;
            end;
         end;
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if i<tm.n;
         fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n');
      else;
         fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
      end;
   end;
else;
   fprintf(fout,['GRANGER CAUSALITY TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  Wald-type test statistic\n  ~~~~~~~~~~~~~~~~~~~~~~~~\n');
   sumnk = 0;
   for i=1:tm.n;
      vari = strrep(tm.myvars(i,:),' ','');
      fprintf(fout,'\nNull Hypothesis:        variable k is Granger noncausal for %s\n',vari);
      fprintf(fout,'Alternative Hypothesis: variable k is Granger causal for %s\n\n',vari);
      if curr_ini.sscorrect==0;
         fprintf(fout,' k             W           df        p-value\n\n');
      else;
         fprintf(fout,' k             F               df         p-value\n\n');
      end;
      for k=1:tm.n;
         if isequal(i,k)==0;
            sumnk = sumnk+1;
            vark = tm.myvars(k,:);
            if curr_ini.sscorrect==0;
               if dfmat(sumnk,1)>0;
                  fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f        %0.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],vark,results(sumnk,1),dfmat(sumnk,1),results(sumnk,2));
               else;
                  fprintf(fout,'%s      Not computed\n',vark);
               end;
            else;
               if dfmat(sumnk,1)>0;
                  fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f        (%0.0f,%0.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],vark,results(sumnk,1),dfmat(sumnk,1),dfmat(sumnk,2),results(sumnk,2));
               else;
                  fprintf(fout,'%s      Not computed\n',vark);
               end;
            end;
         end;
      end;
      if i<tm.n;
         fprintf(fout,'\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n');
      else;
         fprintf(fout,'\n===============================================================================\n\n');
      end;
   end;
end;
fclose(fout);

%
% end of print_gctest.m
%
