function print_proportionality_dummies(tm,curr_ini,sel_dummy_names,test,deg_free,pval,phi,phi_std,kappa,kappa_std,delta,delta_std)

fout = fopen(tm.outputfile,'at');
%
if curr_ini.texoutputformat>=2;
   sh_dn = txt2ltxmath(strtrim(sel_dummy_names(1,:)));
   for i=2:size(sel_dummy_names,1);
      sh_dn = [sh_dn ', ' txt2ltxmath(strtrim(sel_dummy_names(i,:)))];
   end;
   fprintf(fout,['\\subsection*{Proportionality Restrictions for Deterministic Variables} \n\n\\header{For $r$=' num2str(tm.r) '}\n\n']);
   fprintf(fout,'\\header{LR-type test statistic}\n\n');
   fprintf(fout,'\\begin{tabular}{lll}\n');
   fprintf(fout,'$H_0$: & \\multicolumn{2}{l}{%s rows of $\\delta_{3} = \\phi \\kappa''$} \\\\\n',sh_dn);
   fprintf(fout,'$H_A$: & \\multicolumn{2}{l}{%s rows of $\\delta_{3} \\neq \\phi \\kappa''$} \\\\[2mm]\n',sh_dn);
   fprintf(fout,'\\multicolumn{3}{c}{ } \\\\\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,'$LR$ & df & $p$-value \\\\\n');
      fprintf(fout,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],test,deg_free,pval);
   else;
      fprintf(fout,'$F$ & df & $p$-value \\\\\n');
      fprintf(fout,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],test,deg_free(1,1),deg_free(1,2),pval);
   end;
   fprintf(fout,'\\end{tabular}\n\n\\vspace*{3mm}\n\n\\begin{tabular}{llll}\n');
   fprintf(fout,'\\multicolumn{4}{l}{Estimated $\\phi$ with asymptotic standard errors and $t$-ratios} \\\\\n');
   for i=1:tm.n;
      fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.' num2str(curr_ini.decimals,'%0.0f') 'f) & [%0.' num2str(curr_ini.decimals,'%0.0f') 'f] \\\\\n'],txt2ltxmath(strtrim(tm.myvars(i,:))),phi(i,1),phi_std(i,1),inf2nan(phi(i,1)./phi_std(i,1)));
   end;
   fprintf(fout,'\\end{tabular}\n\n\\vspace*{3mm}\n\n');
   prt_str = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f '];
   r_str = 'l';
   h_str = txt2ltxmath(strtrim(sel_dummy_names(1,:)));
   for i=2:size(kappa,1);
      prt_str = [prt_str '& %0.' num2str(curr_ini.decimals,'%0.0f') 'f '];
      r_str = [r_str 'l'];
      h_str = [h_str ' & ' txt2ltxmath(strtrim(sel_dummy_names(i,:)))];
   end;
   prt_std = strrep(prt_str,'%0','(%0');
   prt_std = strrep(prt_std,'f','f)');
   prt_t = strrep(prt_str,'%0','[%0');
   prt_t = strrep(prt_t,'f','f]');
   fprintf(fout,['\\begin{tabular}{l' r_str '}\n']);
   fprintf(fout,['\\multicolumn{' num2str(size(r_str,2)+1,'%0.0f') '}{l}{Estimated $\\kappa$ with asymptotic standard errors and $t$-ratios} \\\\\n']);
   fprintf(fout,[' & ' strrep(h_str,'\rm ','\\rm ') ' \\\\\n']);
   fprintf(fout,[' & ' prt_str '\\\\ \n'],kappa);
   fprintf(fout,[' & ' prt_std '\\\\ \n'],kappa_std);
   fprintf(fout,[' & ' prt_t '\\\\ \n'],inf2nan(kappa./kappa_std));
   fprintf(fout,'\\end{tabular}\n\n\\vspace*{3mm}\n\n');
   %
   r_str = [r_str 'l'];
   prt_str = ['%s & ' prt_str];
   prt_std = [' & ' prt_std];
   prt_t = [' & ' prt_t];
   h_str = [' & ' h_str];
   fprintf(fout,['\\begin{tabular}{' r_str '}\n']);
   fprintf(fout,['\\multicolumn{' num2str(size(r_str,2),'%0.0f') '}{l}{Estimated $\\delta_{3}$ with asymptotic standard errors and $t$-ratios} \\\\\n']);
   fprintf(fout,[strrep(h_str,'\rm ','\\rm ') ' \\\\\n']);
   for i=1:tm.n;
      fprintf(fout,[prt_str '\\\\ \n'],txt2ltxmath(strtrim(tm.myvars(i,:))),delta(i,:)');
      fprintf(fout,[prt_std '\\\\ \n'],delta_std(i,:)');
      fprintf(fout,[prt_t '\\\\ \n'],inf2nan((delta(i,:)')./(delta_std(i,:)')));
   end;
   fprintf(fout,'\\end{tabular}\n\n');
   %
   fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
else;
   sh_dn = strtrim(sel_dummy_names(1,:));
   for i=2:size(sel_dummy_names,1);
      sh_dn = [sh_dn ', ' strtrim(sel_dummy_names(i,:))];
   end;
   fprintf(fout,['TESTING PROPORTIONALITY RESTRICTIONS FOR DETERMINISTIC VARIABLES (for rank=' num2str(tm.r) ') \n\n']);
   fprintf(fout,'  LR-type test statistic\n  ~~~~~~~~~~~~~~~~~~~~~~ \n\n');
   fprintf(fout,['Null Hypothesis:        ' sh_dn ' have proportional parameters \n']);
   fprintf(fout,['Alternative Hypothesis: ' sh_dn ' do not have proportional parameters \n\n']);
   if curr_ini.sscorrect==0;
      fprintf(fout,['LR(' num2str(deg_free,'%0.0f') ')  = ' num2str(test,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' \n']);
   else;
      fprintf(fout,['F(' num2str(deg_free(1,1),'%0.0f') ',' num2str(deg_free(1,2),'%0.0f') ') = ' num2str(test,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' \n']);
   end;
   fprintf(fout,['p-value = ' num2str(pval,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f']) ' \n\n']);
   fprintf(fout,['The proportionality restrictions for ' sh_dn ' are: delta(3) = phi*kappa'', \n']);
   fprintf(fout,'where phi, asymptotic standard errors and t-ratios are: \n\n');
   txt = '';
   for i=1:tm.n;
      txt = strvcat(txt,['   ' tm.myvars(i,:) '    ' num2str(phi(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) '    (' num2str(phi_std(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ')    [' num2str(inf2nan(phi(i,1)./phi_std(i,1)),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ']']);
   end;
   txt = aligntxt(txt);
   for i=1:size(txt,1);
      fprintf(fout,[txt(i,:) ' \n']);
   end;
   sp_str = spacestr(curr_ini.decimals-2);
   fprintf(fout,'\nwhile kappa'', estimated asymptotic standard errors and t-ratios are: \n\n');
   kappa_str = ['       ' strrep(sh_dn,', ',['      ' sp_str])];
   k_str = '     ';
   kstd_str = '     ';
   kt_str = '     ';
   for i=1:size(kappa,1);
      if i<size(kappa,1);
         k_str = [k_str ' ' num2str(kappa(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) '     '];
         kstd_str = [kstd_str '(' num2str(kappa_std(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ')    '];
         kt_str = [kt_str '[' num2str(inf2nan(kappa(i,1)./kappa_std(i,1)),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ']    '];
      else;
         k_str = [k_str ' ' num2str(kappa(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'])];
         kstd_str = [kstd_str '(' num2str(kappa_std(i,1),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ')'];
         kt_str = [kt_str '[' num2str(inf2nan(kappa(i,1)./kappa_std(i,1)),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ']'];
      end;
   end;
   txt = aligntxt(strvcat(kappa_str,k_str,kstd_str,kt_str));
   for i=1:size(txt,1);
      fprintf(fout,[txt(i,:) ' \n']);
   end;
   txt = strvcat(' ','For delta(3) we have that:',' ',kappa_str);
   for i=1:tm.n;
      est_str = [' ' tm.myvars(i,:) '  '];
      std_str = blankstr(size(est_str,2));
      t_str = std_str;
      for j=1:size(kappa,1);
         if j<size(kappa,1);
            est_str = [est_str ' ' num2str(delta(i,j),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) '     '];
            std_str = [std_str '(' num2str(delta_std(i,j),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ')    '];
            t_str = [t_str '[' num2str(inf2nan(delta(i,j)./delta_std(i,j)),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ']    '];
         else;
            est_str = [est_str ' ' num2str(delta(i,j),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'])];
            std_str = [std_str '(' num2str(delta_std(i,j),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ')'];
            t_str = [t_str '[' num2str(inf2nan(delta(i,j)./delta_std(i,j)),['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f']) ']'];
         end;
      end;
      txt = strvcat(txt,est_str,std_str,t_str);
   end;
   txt = aligntxt(txt);
   for i=1:size(txt,1);
      fprintf(fout,[txt(i,:) ' \n']);
   end;
   %
   fprintf(fout,'\n===============================================================================\n\n');
end;
%
fclose(fout);

%
% end of print_proportionality_dummies.m
%
