function properties = getpp_fcn( target )
%GETPP Get all PaperProperties.
%	GPP( h ) returns structure with fields the names of paperproperites and
%   values that of the object h.

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.3 $  $Date: 2001/04/15 11:59:44 $

if nargin == 0
    if length( findall(get(0,'children'), 'type','figure') ) > 0
        target = gcf;
    elseif ~isempty(gcs)
        target = gcs;
    else
        error('No target.')
    end
end

properties.paperpositionmode = getget_fcn(target,'paperpositionmode');
properties.paperposition = getget_fcn(target,'paperposition');
properties.paperorientation = getget_fcn(target,'paperorientation');
properties.paperunits = getget_fcn(target,'paperunits');
properties.papertype = getget_fcn(target,'papertype');
properties.papersize = getget_fcn(target,'papersize');
