function pt = getprinttemplate_fcn( h )
%GETPRINTTEMPLATE Get a figure's PrintTemplate

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.2 $  $Date: 2001/04/15 11:59:57 $

pt = get(h, 'PrintTemplate');
if ~isempty(pt)
  if isfield(pt,'VersionNumber')
    ver = pt.VersionNumber;
  else
    ver = nan;
  end
  if isnan(ver)
    ptnew = printtemplate;
    ptnew.Name = pt.Name;
    ptnew.FrameName = pt.FrameName;
    if pt.DriverColor
      ptnew.DriverColor = 1;
    else
      ptnew.DriverColor = 0;
    end
    ptnew.AxesFreezeTicks = pt.AxesFreezeTicks;
    ptnew.AxesFreezeLimits = pt.AxesFreezeLimits;
    pt = ptnew;
  end
end