function record_3dmovie_fcn(rec_type)

if nargin==0;
   rec_type = 1;
end;

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
set(toolbar.box1,'Visible','off');
myaxes = get(toolbar.print,'UserData');
for j=1:size(myaxes,2);
   this_axes(j).curr_view = get(myaxes(1,j),'View');
   if rec_type==1;
      this_axes(j).new_view = this_axes(j).curr_view(1);
   else;
      this_axes(j).new_view = this_axes(j).curr_view(2);
   end;
end;

num_frames = ceil(180/size(myaxes,2))+1;
rot_change = 2*size(myaxes,2);
num_loop = num_frames;
if rot_change*(num_frames)>360;
   num_loop = num_frames-1;
end;

m = moviein(num_frames);
m(:,1) = getframe(h);
for i=2:num_loop;
   for j=1:size(myaxes,2);
      this_axes(j).new_view = this_axes(j).new_view-rot_change;
      if rec_type==1;
         set(myaxes(1,j),'View',[this_axes(j).new_view this_axes(j).curr_view(2)]);
      else;
         set(myaxes(1,j),'View',[this_axes(j).curr_view(1) this_axes(j).new_view]);
      end;
   end;
   m(:,i) = getframe(h);
end;
%
% in case we did not have a full rotation
%
if num_loop<num_frames;
   new_change = 360-(rot_change*(num_loop-1));
   for j=1:size(myaxes,2);
      this_axes(j).new_view = this_axes(j).new_view-new_change;
      if rec_type==1;
         set(myaxes(1,j),'View',[this_axes(j).new_view this_axes(j).curr_view(2)]);
      else;
         set(myaxes(1,j),'View',[this_axes(j).curr_view(1) this_axes(j).new_view]);
      end;
   end;
   m(:,num_frames) = getframe(h);
end;
%
% collecting figure information
%
old_units = get(h,'Units');
set(h,'Units','pixels');
movie_pos = get(h,'Position')+[-25 -25 50 50];
set(h,'Units',old_units);
if movie_pos(1)<0;
   movie_pos(3) = movie_pos(3)-movie_pos(1);
   movie_pos(1) = 0;
end;
if movie_pos(2)<0;
   movie_pos(4) = movie_pos(4)-movie_pos(2);
   movie_pos(2) = 0;
end;
movie_color = get(h,'Color');
movie_renderer = get(h,'Renderer');
if rec_type==1;
   name_type = ' (horizontal)';
else;
   name_type = ' (vertical)';
end;
movie_name = [get(h,'Name') name_type];
curr_ini = find_inisettings;
save([curr_ini.model.modelsdir 'svar-temp-' num2str(rec_type) '.mat'],'m','movie_color','movie_pos','movie_renderer','movie_name');
set(toolbar.movie,'Enable','on','UserData',[curr_ini.model.modelsdir 'svar-temp-' num2str(rec_type) '.mat']);
set(toolbar.box1,'Visible','on');

%
% end of record_3dmovie_fcn.m
%