function setlogtext(textstr,cw)

%
% retrieve old log text
%

if nargin==1;
   cw = findobj('Type','figure','Tag','StructuralVAR');
end;
model = get(cw,'UserData');
old_logtext = get(model.estimation_log,'String');
list_top = get(model.estimation_log,'UserData');

%
% create new log text
%

logtext = strvcat(old_logtext,textstr);

%
% Determine if ListboxTop property should be changed
%

if list_top>1;
   list_top = list_top+size(textstr,1);
else;
   fsize = get(model.estimation_log,'FontSize');
   points_per_pixel = 72/get(0,'ScreenPixelsPerInch');
   log_height = floor(303*points_per_pixel);
   logtext_height = fsize*size(logtext,1);
   if logtext_height>log_height;
      list_top = list_top+size(textstr,1);
   end;
end;

%
% Insert new properties into log control
%

set(model.estimation_log,'String',logtext,'ListboxTop',list_top,'UserData',list_top);
drawnow;

%
% end of setlogtext.m
%
