function [pagepos,axespos,newfiginfo] = shadow_figure(figinfo)

this_fig = figure('Units','pixels', ...
   'Position',figinfo.figsize, ...
   'MenuBar','none', ...
   'ToolBar','none', ...
   'InvertHardcopy',figinfo.inverthardcopy, ...
   'PaperOrientation',figinfo.paperorientation, ...
   'PaperType',figinfo.papertype, ...
   'PaperUnits',figinfo.paperunits, ...
   'PaperPositionMode',figinfo.paperpositionmode, ...
   'Visible','off');

if strcmp(figinfo.paperpositionmode,'manual')==1;
   if isfield(figinfo,'manualpaperposition')==1;
      set(this_fig,'PaperPosition',figinfo.manualpaperposition);
   end;
end;

if isfield(figinfo,'manualpaperunits')==1;
   set(this_fig,'PaperUnits',figinfo.manualpaperunits);
   figinfo.paperunits = figinfo.manualpaperunits;
end;

figinfo.manualpaperposition = get(this_fig,'PaperPosition');
figinfo.paperposition = get(this_fig,'PaperPosition');
figinfo.papersize = get(this_fig,'PaperSize');

set(this_fig,'PaperUnits','points');
paper_size = get(this_fig,'PaperSize');
paper_position = get(this_fig,'PaperPosition');

if strcmp(figinfo.paperorientation,'portrait')==1;
   pagepos = [200+((200-(200*(paper_size(1)/paper_size(2))))/2) 313 200*(paper_size(1)/paper_size(2)) 200];
else;
   pagepos = [200 300+((226-(200*(paper_size(2)/paper_size(1))))/2) 200 200*(paper_size(2)/paper_size(1))];
end;

axespos = zeros(1,4);
if strcmp(figinfo.paperpositionmode,'auto')==1;
   axespos(3) = pagepos(3)*(paper_position(3)/paper_size(1));
   axespos(4) = pagepos(4)*(paper_position(4)/paper_size(2));
   axespos(1) = pagepos(1)+( (pagepos(3)-axespos(3))/2 );
   axespos(2) = pagepos(2)+( (pagepos(4)-axespos(4))/2 );
else;
   axespos(3) = pagepos(3)*(paper_position(3)/paper_size(1));
   axespos(4) = pagepos(4)*(paper_position(4)/paper_size(2));
   axespos(1) = pagepos(1)+(pagepos(3)*(paper_position(1)/paper_size(1)));
   axespos(2) = pagepos(2)+(pagepos(4)*(paper_position(2)/paper_size(2)));
end;

if nargout==3;
   newfiginfo = figinfo;
end;

delete(this_fig);

%
% end of shadow_figure.m
%
