function show_exclude_dummies(fig,tm,curr_ini)

set(fig,'Visible','off');
drawnow;
%
% compute the tests
%
[tests,pvals,dfs] = exclude_dummies(tm.epsilon,tm.Z0,tm.Z1,tm.Z2,tm.deter,tm.r,tm.p,tm.pe,tm.q1,tm.q0,tm.df,tm.ad,tm.datad,tm.restrict,tm.modelsdir,tm.modelfile,tm.dcoint,curr_ini.reestbeta,curr_ini.sscorrect,1);
%
num_const = tm.ad;
num_dummies = tm.datad;
%
dummy_names = vecstr(tm.deter);
dummy_names = dummy_names(1+num_const:num_dummies+num_const,:);
sp_str = spacestr(curr_ini.decimals-2);
%
% create the output text string    
%
txt = strvcat(' ',['TESTING EXCLUSION RESTRICTIONS ON DETERMINISTIC VARIABLES (for rank=' num2str(tm.r) ')']);
numchar = size(txt,2);
addtxt = '';
for i=1:numchar;
   addtxt = strcat(addtxt,'=');
end;
txt = strvcat(txt,addtxt,' ');
txt = strvcat(txt,'  LR-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~',' ');
%
txt = strvcat(txt,'Null Hypothesis:        Dummy k has zero coefficients');
txt = strvcat(txt,'Alternative Hypothesis: Dummy k does not have zero coefficients',' ');
if curr_ini.sscorrect==0;
   txt = strvcat(txt,['   k       LR    ' sp_str '  df       p-value']);
   for i=1:num_dummies;
      out = sprintf([' %s   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f   %3.0f     %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'],dummy_names(i,:),tests(i,1),dfs(i,1),pvals(i,1));
      txt = strvcat(txt,out);
   end;
   txt = strvcat(txt,' ');
   if num_dummies>1;
      txt = strvcat(txt,'Null Hypothesis:        All dummies have zero coefficients','Alternative Hypothesis: All dummies do not have zero coefficients',' ');
      txt = strvcat(txt,['LR(' num2str(dfs(num_dummies+1,1),'%0.0f') ')  = ' num2str(tests(num_dummies+1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
      txt = strvcat(txt,['p-value = ' num2str(pvals(num_dummies+1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
   end;
else;
   txt = strvcat(txt,['   k         F    ' sp_str '    df        p-value']);
   for i=1:num_dummies;
      out = sprintf([' %s   %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f   (%2.0f,%3.0f)    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'],dummy_names(i,:),tests(i,1),dfs(i,1),dfs(i,2),pvals(i,1));
      txt = strvcat(txt,out);
   end;
   txt = strvcat(txt,' ');
   if num_dummies>1;
      txt = strvcat(txt,'Null Hypothesis:        All dummies have zero coefficients','Alternative Hypothesis: All dummies do not have zero coefficients',' ');
      txt = strvcat(txt,['F(' num2str(dfs(num_dummies+1,1),'%0.0f') ',' num2str(dfs(num_dummies+1,2),'%0.0f') ') = ' num2str(tests(num_dummies+1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])]);
      txt = strvcat(txt,['p-value  = ' num2str(pvals(num_dummies+1,1),['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
   end;
end;

%
% display the results
%
realscrsz = get(0,'ScreenSize');
textgui(txt,'Exclusion Restrictions - Deterministic Variables',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
%
set(fig,'Visible','on');
drawnow;
%
% end of show_exclude_dummies.m
%
