function stretch_lines(direction)

this_axes = gca;
my_lines = sort(findobj(this_axes,'Type','line')');
if isempty(my_lines)==0;
   if strcmp(direction,'h')==1;
      for i=1:size(my_lines,2);
         if min(get(my_lines(1,i),'YData'))==max(get(my_lines(1,i),'YData'));
            new_ydata = get(my_lines(1,i),'XData');
            y_lim = get(this_axes,'XLim');
            if size(new_ydata,1)==1;
               if size(new_ydata,2)==2;
                  new_ydata = [y_lim(1,1) y_lim(1,2)];
               else;
                  new_ydata = [y_lim(1,1) new_ydata(1,2:size(new_ydata,2)-1) y_lim(1,2)];
               end;
            else;
               if size(new_ydata,1)==2;
                  new_ydata = [y_lim(1,1);y_lim(1,2)];
               else;
                  new_ydata = [y_lim(1,1);new_ydata(2:size(new_ydata,2)-1,1);y_lim(1,2)];
               end;
            end;
            set(my_lines(1,i),'XData',new_ydata);
         end;
      end;
   elseif strcmp(direction,'v')==1;
      for i=1:size(my_lines,2);
         if min(get(my_lines(1,i),'XData'))==max(get(my_lines(1,i),'XData'));
            new_xdata = get(my_lines(1,i),'YData');
            x_lim = get(this_axes,'YLim');
            if size(new_xdata,1)==1;
               if size(new_xdata,2)==2;
                  new_xdata = [x_lim(1,1) x_lim(1,2)];
               else;
                  new_xdata = [x_lim(1,1) new_xdata(1,2:size(new_xdata,2)-1) x_lim(1,2)];
               end;
            else;
               if size(new_xdata,1)==2;
                  new_xdata = [x_lim(1,1);x_lim(1,2)];
               else;
                  new_xdata = [x_lim(1,1);new_xdata(2:size(new_xdata,2)-1,1);x_lim(1,2)];
               end;
            end;
            set(my_lines(1,i),'YData',new_xdata);
         end;
      end;
   elseif strcmp(direction,'d')==1;
      %
      % a diagonal strech
      %
      for i=1:size(my_lines,2);
         x_data = get(my_lines(1,i),'XData');
         y_data = get(my_lines(1,i),'YData');
         if sum(x_data-y_data)==0;
            x_lim = get(this_axes,'XLim');
            y_lim = get(this_axes,'YLim');
            new_x_data = [min(x_lim(1),y_lim(1)) max(x_lim(2),y_lim(2))];
            new_y_data = new_x_data;
            set(my_lines(1,i),'XData',new_x_data,'YData',new_y_data);
         end;
      end;
   end;
end;

%
% end of stretch_lines.m
%