function toolbar_addcolorbar_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% check if current axes is in myaxes. if not set myaxes(1,1) to
% current axes
%

curr_axes = myaxes(1,1);
for i=1:size(myaxes,2);
   if gca==myaxes(1,i);
      curr_axes = myaxes(1,i);
      break;
   end;
end;

axes(curr_axes);

old_leg = get(curr_axes,'UserData');
if (isempty(old_leg)==1)|(ishandle(old_leg)==0);
   old_leg = find_legend(curr_axes);
end;

bg_color = [];
border_color = [];
text_color = [];
text_fontname = '';
text_fontsize = [];
text_fontweight = '';
text_fontangle = '';
text_fontunits = '';
if (isempty(old_leg)==0)&(ishandle(old_leg)==1);
   bg_color = get(old_leg,'Color');
   border_color = get(old_leg,'XColor');
   text_strings = findobj(old_leg,'Type','text')';
   if isempty(text_strings)==0;
      text_color = get(text_strings(1,1),'Color');
      text_fontname = get(text_strings(1,1),'FontName');
      text_fontsize = get(text_strings(1,1),'FontSize');
      text_fontweight = get(text_strings(1,1),'FontWeight');
      text_fontangle = get(text_strings(1,1),'FontAngle');
      text_fontunits = get(text_strings(1,1),'FontUnits');
   end;
end;

%
% adding a real colorbar
%
ax_fontangle = get(curr_axes,'FontAngle');
ax_fontname = get(curr_axes,'FontName');
ax_fontsize = get(curr_axes,'FontSize');
ax_fontunits = get(curr_axes,'FontUnits');
ax_fontweight = get(curr_axes,'FontWeight');

this_colorbar = colorbar_fcn;
set(this_colorbar,'Tag','colorbar');
%set(this_colorbar,'YLim',get(curr_axes,'ZLim'));
set(this_colorbar,'FontSize',ax_fontsize);
set(this_colorbar,'FontName',ax_fontname);
set(this_colorbar,'FontWeight',ax_fontweight);
set(this_colorbar,'FontAngle',ax_fontangle);
set(this_colorbar,'FontUnits',ax_fontunits);
colorbar_pos = get(this_colorbar,'Position');
set(this_colorbar,'Position',[colorbar_pos(1)+(2*colorbar_pos(3)/3) colorbar_pos(2) colorbar_pos(3)/3 colorbar_pos(4)]);
new_leg = get(this_colorbar,'UserData');
if (isempty(new_leg)==0)&(ishandle(new_leg)==1)
   set(curr_axes,'UserData',new_leg);
end;
set(this_colorbar,'UserData',curr_axes);
kids = get(this_colorbar,'Children')';
set(kids(1,1),'UserData','');

%
% create a new context menu for the legend
%

if (isempty(new_leg)==0)&(ishandle(new_leg)==1)
   leg_ud = get(new_leg,'UserData');
   legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
   uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
   uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
   uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
   uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
   uimenu('Parent',legcontext,'Label','Reorder Legend','Separator','on','Callback','reorder_legend_fcn');
   uimenu('Parent',legcontext,'Label','Hide Legend','Separator','on','Callback','toolbar_legend_fcn');
   uimenu('Parent',legcontext,'Label','Lock Legend','Separator','on','Callback','legend_lock_fcn');
   leg_ud.UIContextMenu = legcontext;
   set(new_leg,'UIContextMenu',legcontext,'UserData',leg_ud);
   set(get(new_leg,'Children'),'UIContextMenu',legcontext);
   if isempty(bg_color)==0;
      set(new_leg,'Color',bg_color);
   end;
   if isempty(border_color)==0;
      set(new_leg,'XColor',border_color);
      set(new_leg,'YColor',border_color);
   end;
   if isempty(text_color)==0;
      text_strings = findobj(new_leg,'Type','text')';
      for i=1:size(text_strings,2);
         set(text_strings(1,i),'Color',text_color);
         set(text_strings(1,i),'FontName',text_fontname);
         set(text_strings(1,i),'FontSize',text_fontsize);
         set(text_strings(1,i),'FontAngle',text_fontangle);
         set(text_strings(1,i),'FontWeight',text_fontweight);
         set(text_strings(1,i),'FontUnits',text_fontunits);
      end;
   end;
end;

%
% fix menus
%

par = get(toolbar.deletecolorbar,'Parent');
d_pos = get(toolbar.deletecolorbar,'Position');

if isfield(toolbar,'colorbar')==0;
   toolbar.colorbar = uimenu('Parent',par, ...
      'Label','&Hide Colorbar', ...
      'Position',d_pos, ...
      'Callback','toolbar_colorbar_fcn', ...
      'Enable','on', ...
      'Tag','ColorBar');
end;

if strcmp(get(toolbar.deletecolorbar,'Label'),'Delete Colorbar')==0;
   set(toolbar.deletecolorbar,'Label','&Delete Colorbar','Callback','delete_colorbar_fcn');
end;

%
%  and current axes context menu
%

create_axes_contextmenu_fcn(curr_axes);

%
% update figure user data
%

set(h,'UserData',toolbar);

%
% end of toolbar_addcolorbar_fcn.m
%
