function toolbar_name_fcn

h = gcf;
old_name = get(h,'Name');

scrsz = get(0,'ScreenSize');
curr_ini = find_inisettings;

toolbar_namegui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
   'FileName','toolbar_name_fcn.m', ...
   'MenuBar','none', ...
   'Units','pixels', ...
   'Position',[scrsz(3)/2-180 (scrsz(4)-110)/2 360 110], ...
   'Tag','FigSheetDlg', ...
   'Resize','off', ...
   'Visible','off', ...
   'Name','New Figure Name', ...
   'NumberTitle','off', ...
   'WindowStyle','modal', ...
   'CloseRequestFcn','closegui', ...
   'ToolBar','none');

if matlabnumber>=7.0;
   set(toolbar_namegui,'DockControl','off');
end;

axesbox([2 2 358 103],'Figure Name',65,[0.5 1]);

uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[12 70 270 20], ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Style','text', ...
   'HorizontalAlignment','left', ...
   'String','Select new figure name', ...
   'Tag','Text');

toolbar_name.select = uicontrol('Units','pixels', ...
   'BackgroundColor',[1 1 1], ...
   'Position',[12 50 336 20], ...
   'String',old_name, ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'HorizontalAlignment','Left', ...
   'Style','edit', ...
   'Enable','on', ...
   'Tag','toolbar_nameEdit');

%
% Two buttons to select action
%

toolbar_name.ok = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[102 12 75 25], ...
   'String','OK', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'UserData','waiting', ...
   'Tag','ButtonOK');

toolbar_name.cancel = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[182 12 75 25], ...
   'String','Cancel', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'Tag','ButtonCancel');

if (iswinnt==1)&(iscompiled==1)&(curr_ini.noicon==1);
   set(toolbar_namegui,'WindowStyle','normal');
   prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(toolbar_namegui,'Name') ' NULL'];
   dos(prog);
   wait_fcn(curr_ini.delay);
   pos = get(toolbar_namegui,'Position');
   set(toolbar_namegui,'Position',[0 0 1 1]);
end;

set(toolbar_namegui,'Visible','on');
drawnow;
if (iswinnt==1)&(iscompiled==1);
   if curr_ini.noicon==1;
      drawnow;
      set(toolbar_namegui,'WindowStyle','modal');
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(toolbar_namegui,'Name') ' NULL'];
      dos(prog);
      wait_fcn(curr_ini.delay);
      set(toolbar_namegui,'Position',pos);
   end;
   drawnow;
   if matlabnumber<7;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(toolbar_namegui,'Name') ' 2'];
      dos(prog);
      drawnow;
   else;
      uicontrol(toolbar_name.ok);
   end;
   if curr_ini.noicon==1;
      set(toolbar_namegui,'Position',pos);
   end;
elseif matlabnumber>=7;
   uicontrol(toolbar_name.ok);
end;
waitfor(toolbar_namegui,'waitstatus','inactive');
%uiwait(toolbar_namegui);

action = get(get(toolbar_namegui,'CurrentObject'),'String');

if isempty(action)==1;
   action = 'Cancel';
end;

if strcmp(action,'OK')==1;
   new_name = get(toolbar_name.select,'String');
   new_name = strtrim(new_name);
   if strcmp(new_name,'')==0;
      set(h,'Name',new_name);
   end;
end;

delete(toolbar_namegui);
drawnow;

%
% end of toolbar_name_fcn.m
%
