function toolbar_saveas_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

if ishandle(h)==1;
   thish = findobj('Tag','StructuralVAR');
   if isempty(thish)==1;
      thish = min(findobj('Type','figure')');
   end;
   model = get(thish,'UserData');
   if isempty(get(model.outputfile,'String'))==0;
      basedir = getpath(get(model.outputfile,'String'));
   else;
      basedir = pwd;
      if strcmp(computer,'PCWIN')==1;
         basedir = [basedir '\'];
      else;
         if isunix==1;
            basedir = [basedir '/'];
         else;
            basedir = [basedir '\'];
         end;
      end;
   end;
   if matlabnumber>=6.0;
      inputfiletype = cell(16,2);
      inputfiletype{1,1} = '*.fig';
      inputfiletype{1,2} = 'MatLab Figure Files (*.fig)';
      inputfiletype{2,1} = '*.eps';
      inputfiletype{2,2} = 'Encapsulated PostScript Files (*.eps)';
      inputfiletype{2,1} = '*.ai';
      inputfiletype{2,2} = 'Adobe Illustrator Files (*.ai)';
      inputfiletype{3,1} = '*.ps';
      inputfiletype{3,2} = 'PostScript Files (*.ps)';
      inputfiletype{4,1} = '*.bmp';
      inputfiletype{4,2} = 'Windows Bitmap Files (*.bmp)';
      inputfiletype{5,1} = '*.hgl';
      inputfiletype{5,2} = 'HP Graphics Language Files (*.hgl)';
      num = 5;
      etx = '.fig .eps .ai .ps .bmp .hgl ';
      if isgs==1;
         inputfiletype{6,1} = '*.png';
         inputfiletype{6,2} = 'Portable Network Graphics (*.png)';
         inputfiletype{7,1} = '*.jpg;*.jpeg';
         inputfiletype{7,2} = 'JPEG Files (*.jpg, *.jpeg)';
         inputfiletype{8,1} = '*.tif;*.tiff';
         inputfiletype{8,2} = 'Tagged Image Format Files (*.tif, *.tiff)';
         inputfiletype{9,1} = '*.pcx';
         inputfiletype{9,2} = 'Paintbrush 24-bit Files (*.pcx)';
         inputfiletype{10,1} = '*.pbm';
         inputfiletype{10,2} = 'Portable Bitmap Files (*.pbm)';
         inputfiletype{11,1} = '*.pgm';
         inputfiletype{11,2} = 'Portable Graymap Files (*.pgm)';
         inputfiletype{12,1} = '*.ppm';
         inputfiletype{12,2} = 'Portable Pixmap Files (*.ppm)';
         inputfiletype{13,1} = '*.pdf';
         inputfiletype{13,2} = 'Portable Document Format Files (*.pdf)';
         num = 13;
         etx = [etx '.png .jpg .jpeg .tif .tiff .pcx .pbm .pgm .ppm .pdf '];
      end;
      if ispstoedit==1;
         inputfiletype{num+1,1} = '*.emf';
         inputfiletype{num+1,2} = 'Windows Enhanced Metafiles (*.emf)';
         inputfiletype{num+2,1} = '*.wmf';
         inputfiletype{num+2,2} = 'Windows Metafiles (*.wmf)';
         inputfiletype{num+3,1} = '*.tex';
         inputfiletype{num+3,2} = 'LaTeX2e Picture Files (*.tex)';
         etx = [etx '.emf .wmf .tex '];
         num = num+3;
      end;
      inputfiletype = inputfiletype(1:num,:);
   else;
      inputfiletype = [basedir '*.fig;*.eps;*.ps;*.bmp'];
      etx = '.fig .eps .ps .bmp ';
      cstat = isgs;
      if cstat==1;
         inputfiletype = [inputfiletype ';*.png;*.jpg;*.pdf'];
         etx = [etx '.png .jpg .pdf '];
      end;
      if ispstoedit==1;
         inputfiletype = [inputfiletype ';*.wmf'];
         etx = [etx '.wmf '];
      end;
   end;
   if isempty(get(toolbar.name,'UserData'))==0;
      if ischar(get(toolbar.name,'UserData'))==1;
         this_name = get(toolbar.name,'UserData');
         if fileexist(this_name)==1;
            inputfiletype = this_name;
         end;
      end;
   end;
   [filename,filepath] = uiputfile(inputfiletype,'Save As');
   drawnow;
   if isnumeric(filename)==0;
      old_pointer = get(h,'Pointer');
      if strcmp(old_pointer,'custom')==1;
         old_pointer_shape_cdata = get(h,'PointerShapeCData');
      end;
      set(h,'Pointer','watch');
      set(toolbar.saveas,'UserData',1);
      thisext = strrep(getext(filename),' ','');
      if strcmp(thisext,'')==1;
         filename = [filename '.eps'];
      elseif strcmp(thisext,'.')==1;
         filename = [getname(filename) '.eps'];
      else;
         w = findstr([thisext ' '],etx);
         if isempty(w)==1;
            filename = [getname(filename) '.eps'];
         end;
      end;
      filename = [filepath filename];
      thisext = getext(filename);
      if strcmp(thisext,'.eps')==1;
         set(h,'ResizeFcn','print_resize_legend_fcn');
         mstat = saveas_fcn(h,filename,'epsc');
         set(h,'ResizeFcn','toolbar_resize_fcn');
      elseif strcmp(thisext,'.ps')==1;
         set(h,'ResizeFcn','print_resize_legend_fcn');
         mstat = saveas_fcn(h,filename,'psc');
         set(h,'ResizeFcn','toolbar_resize_fcn');
      elseif strcmp(thisext,'.fig')==1;
         set(toolbar.name,'UserData',filename);
         mstat = saveas_fcn(h,filename);
      elseif strcmp(thisext,'print_resize_legend_fcn')==1;
         txt = 'You didn''t select a graphics format. Unable to save graph.';
         about(txt,'information','No format...',120,350);
      else;
         set(h,'ResizeFcn','print_resize_legend_fcn');
         mstat = saveas_fcn(h,filename);
         set(h,'ResizeFcn','toolbar_resize_fcn');
      end;
      set(toolbar.saveas,'UserData',0);
      set(h,'Pointer',old_pointer);
      if strcmp(old_pointer,'custom')==1;
         set(h,'PointerShapeCData',old_pointer_shape_cdata);
      end;
   end;
else;
   setlogtext(strvcat(' ','Error: Current figure doesn''t have a handle! Unable to save...'));
end;

%
% end of toolbar_saveas_fcn.m
%
