%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for vectorizing an mxn character      %
%          matrix A "column by column". "Elements" are separated %
%          by a space, tab, or end of line                       %
%                                                                %
%          Function: vecstr                                      %
%                                                                %
%          Input:                                                %
%                        A: mxn matrix                           %
%                        addon: string to add on (optional)      %
%                                                                %
%          Output:                                               %
%          		 veca: sxq column vectorization of A     %
%                                                                %
%          This version:        October 30, 2002                 %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2002          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function veca = vecstr(A,addon)

if nargin<2;
   addon = '';
end;

[numlength numchar] = size(A);
veca = '';

j=1;
while j<=numlength;
   i = 1;
   iold = 1;
   while i<=numchar;
      if strcmp(A(j,i),' ')==1;
         veca = strvcat(veca,[A(j,iold:i-1) addon]);
         iold = i+1;
      elseif strcmp(A(j,i),'	')==1;
         veca = strvcat(veca,[A(j,iold:i-1) addon]);
         iold = i+1;
      end;
      if i==numchar;
         veca = strvcat(veca,[A(j,iold:numchar) addon]);
      end;
      i = i+1;
   end;
   j = j+1;
end;

%
% end of vecstr.m
%
